Attribute VB_Name = "MapLis"
Option Explicit

Public Type FileFormatA
            LineID As String * 7
            ArtibCodeMin As String * 2
            NumPts As String * 6
            AtribCodeMaj As String * 5
End Type
Public Record1 As FileFormatA

Public Type FileFormatB
            LatDeg As String * 2
            LatMinute As String * 2
            LatSec As String * 2
            LatHemi As String * 1
            LonDeg As String * 3
            LonMinute As String * 2
            LonSec As String * 2
            LonHemi As String * 1
            SeqCount As String * 5
End Type
Public Record2 As FileFormatB

Public Type FileFormatC
            fRangeRecNum As String * 13 'First 12 records in file. One record for each
            rNumOfMaps As String * 10   'map range from 2048 to 1 mile map range
End Type
Public MapListRange As FileFormatC

Public Type FileFormatD
            MapFileName As String * 8
            CenLatDeg As String * 2
            CenLatDec As String * 4
            CenLatHemi As String * 1
            CenLonDeg As String * 3
            CenLonDec As String * 4
            CenLonHemi As String * 1
End Type
Public MapListData As FileFormatD

Public Type StuffMap
            MapRange As Integer
            OldRange As Integer
            LatCen As Single
            LonCen As Single
            OldLatCen As Single
            OldLonCen As Single
            LatMax As Single
            LatMin As Single
            LonMax As Single
            LonMin As Single
            RangeY As Single
            RangeX As Single
End Type
Public MapParam As StuffMap


Public Type LSec
            SecLonMax As Single
            SecLatMax As Single
            SecLonMin As Single
            SecLatMin As Single
End Type

Public LSecGrid(21) As LSec

Public Type Apt
            x As Single
            y As Single
End Type

Public AnchorPT As Apt

Public Type JohnData1
            LatDec As Single
            LonDec As Single
            Scolor As Long
            Scallsign As String
            DisPlaySym As Boolean
            SymFile As String
End Type

Public SymLoc(32000) As JohnData1

Public ReckFlag As Boolean
Public MouseDragFlag As Boolean
Public LoadFlag As Boolean
Public SymIndex As Integer
Public SIDrawSym As Boolean
Public ScaleOnce As Boolean
'Public SameMapRange As Boolean

Public Sub DrawMap()
Dim x As Integer
Dim NP As Integer
Dim FirstTime As Boolean
Dim y As Integer
Dim LatDec As Single
Dim LonDec As Single
Dim LineColor As Long
Dim SfileEnd(4) As String
Dim SfileBeg(21) As String
Dim FileOpenStart As Integer
Dim FileOpenEnd As Integer
Dim Atrib As Integer
Dim W As Integer
Dim OldPointer As Integer
Dim HoldValue As Integer
Dim FileNumber As Integer

SfileEnd(1) = "PB"
SfileEnd(2) = "RDI"
SfileEnd(3) = "RDL"
SfileEnd(4) = "WB"

SfileBeg(1) = "S01_"
SfileBeg(2) = "S02_"
SfileBeg(3) = "S03_"
SfileBeg(4) = "S04_"
SfileBeg(5) = "S05_"
SfileBeg(6) = "S06_"
SfileBeg(7) = "S07_"
SfileBeg(8) = "S08_"
SfileBeg(9) = "S09_"
SfileBeg(10) = "S10_"
SfileBeg(11) = "S11_"
SfileBeg(12) = "S12_"
SfileBeg(13) = "S13_"
SfileBeg(14) = "S14_"
SfileBeg(15) = "S15_"
SfileBeg(16) = "S16_"
SfileBeg(17) = "S17_"
SfileBeg(18) = "S18_"
SfileBeg(19) = "S19_"
SfileBeg(20) = "S20_"
SfileBeg(21) = "S21_"


FileOpenEnd = 0
FileOpenStart = 0
OldPointer = MapFrm!Map1.MousePointer
MapFrm!Map1.MousePointer = vbHourglass

For W = 1 To 15
  If LSecGrid(W).SecLatMax >= MapParam.LatMax And LSecGrid(W).SecLonMax >= MapParam.LonMax And LSecGrid(W).SecLatMin <= MapParam.LatMax And LSecGrid(W).SecLonMin <= MapParam.LonMax Then
    FileOpenEnd = W
  End If
Next W

For W = 1 To 15
  If LSecGrid(W).SecLatMax >= MapParam.LatMin And LSecGrid(W).SecLonMax >= MapParam.LonMin And LSecGrid(W).SecLatMin <= MapParam.LatMin And LSecGrid(W).SecLonMin <= MapParam.LonMin Then
    FileOpenStart = W
    Exit For
  End If
Next W
  
If FileOpenStart = 0 Then
  For W = 1 To 15
    If LSecGrid(W).SecLatMax >= MapParam.LatCen And LSecGrid(W).SecLonMax >= MapParam.LonCen And LSecGrid(W).SecLatMin <= MapParam.LatCen And LSecGrid(W).SecLonMin <= MapParam.LonCen Then
      Exit For
    End If
  Next W
  If MapParam.MapRange <= 64 Then FileOpenStart = W
End If
  
  
If FileOpenEnd > 0 And FileOpenStart > 0 And FileOpenEnd < FileOpenStart Then
  HoldValue = FileOpenStart
  FileOpenStart = FileOpenEnd
  FileOpenEnd = HoldValue
End If

If FileOpenEnd = 0 And FileOpenStart = 0 Then
  FileOpenEnd = 15
  FileOpenStart = 1
Else
  If FileOpenEnd = 0 Then
    Select Case FileOpenStart
           Case 1, 2, 3, 4
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenEnd = FileOpenStart
                    Case 32, 64, 128
                      FileOpenEnd = 7
                    Case 256, 512
                      FileOpenEnd = 11
                    Case Else
                      FileOpenEnd = 15
             End Select
           Case 5, 6, 7
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenEnd = FileOpenStart
                    Case 32, 64, 128
                      FileOpenEnd = 11
                    Case Else
                      FileOpenEnd = 15
             End Select
           Case 8, 9, 10, 11
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenEnd = FileOpenStart
                    Case Else
                      FileOpenEnd = 15
             End Select
           Case 12, 13, 14, 15
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenEnd = FileOpenStart
                    Case Else
                      FileOpenStart = 1
                      FileOpenEnd = 15
             End Select
    End Select
  End If
  If FileOpenStart = 0 Then
    Select Case FileOpenEnd
           Case 1, 2, 3, 4
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16, 32
                      FileOpenStart = FileOpenEnd
                      
                    Case 64, 128
                      FileOpenStart = FileOpenEnd
                      FileOpenEnd = 7
                    Case 256, 512
                      FileOpenStart = FileOpenEnd
                      FileOpenEnd = 11
                    Case Else
                      FileOpenStart = FileOpenEnd
                      FileOpenEnd = 15
             End Select
           
           Case 5, 6, 7
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenStart = FileOpenEnd
                    Case 32, 64, 128
                      FileOpenStart = 1
                    Case Else
                      FileOpenEnd = 15
                      FileOpenStart = 1
             End Select
           Case 8, 9, 10, 11
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenStart = FileOpenEnd
                    Case Else
                      FileOpenEnd = 15
                      FileOpenStart = 1
             End Select
           Case 12, 13, 14, 15
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenStart = FileOpenEnd
                    Case Else
                      FileOpenStart = 1
                      FileOpenEnd = 15
             End Select
    End Select
  End If
End If
  
FileNumber = FreeFile
For W = FileOpenStart To FileOpenEnd
  Select Case MapParam.MapRange
         Case Is < 32
           y = 2
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(y) + ".GRF" For Random As FileNumber Len = 20
           GoSub READFILE
           y = 3
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(y) + ".GRF" For Random As FileNumber Len = 20
           GoSub READFILE
           y = 4
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(y) + ".GRF" For Random As FileNumber Len = 20
           GoSub READFILE
         Case Is >= 32
           y = 1
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(y) + ".GRF" For Random As FileNumber Len = 20
           GoSub READFILE
           y = 2
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(y) + ".GRF" For Random As FileNumber Len = 20
           GoSub READFILE
           y = 4
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(y) + ".GRF" For Random As FileNumber Len = 20
           GoSub READFILE
  End Select
Next W

MapFrm!Map1.MousePointer = OldPointer
MapFrm!Map1.Picture = MapFrm!Pic1.Image
If SIDrawSym Then Call ReDrawSymS
SIDrawSym = True
 
Exit Sub

READFILE:
  Do Until EOF(1)
    Get #FileNumber, , Record1
    If EOF(1) Then Exit Do
    NP = Val(Record1.NumPts)
    Atrib = Val(Record1.ArtibCodeMin)
    FirstTime = True
    For x = 1 To NP
      Get #FileNumber, , Record2
      LatDec = Val(Record2.LatDeg) + Val(Record2.LatMinute) / 60 + Val(Record2.LatSec) / 3600
      LonDec = Val(Record2.LonDeg) + Val(Record2.LonMinute) / 60 + Val(Record2.LonSec) / 3600
      If LatDec < MapParam.LatMax And LatDec > MapParam.LatMin Then
        If LonDec < MapParam.LonMax And LonDec > MapParam.LonMin Then
          Select Case y
                 Case 1
                   LineColor = QBColor(6)
                   If Atrib = 1 Or Atrib = 2 Or Atrib = 3 Or Atrib = 4 Or Atrib = 5 Or Atrib = 6 Then
                     If FirstTime Then
                       MapFrm!Map1.PSet (LonDec, LatDec), LineColor
                       MapFrm!Pic1.PSet (LonDec, LatDec), LineColor
                     Else
                       MapFrm!Map1.Line -(LonDec, LatDec), LineColor
                       MapFrm!Pic1.Line -(LonDec, LatDec), LineColor
                     End If
                     FirstTime = False
                   End If
                 Case 2
                   LineColor = QBColor(2)
                   If FirstTime Then
                     MapFrm!Map1.PSet (LonDec, LatDec), LineColor
                     MapFrm!Pic1.PSet (LonDec, LatDec), LineColor
                   Else
                     MapFrm!Map1.Line -(LonDec, LatDec), LineColor
                     MapFrm!Pic1.Line -(LonDec, LatDec), LineColor
                   End If
                   FirstTime = False
                 Case 3
                   If Atrib = 13 Or Atrib = 15 Or Atrib = 19 Or Atrib = 20 Then LineColor = QBColor(4)
                   If Atrib = 14 Or Atrib = 16 Or Atrib = 17 Or Atrib = 18 Then LineColor = QBColor(8)
                   If Atrib > 20 And Atrib < 62 Then LineColor = QBColor(8)
                   If Atrib = 62 Then LineColor = QBColor(1)
                   If FirstTime Then
                    MapFrm!Map1.PSet (LonDec, LatDec), LineColor
                    MapFrm!Pic1.PSet (LonDec, LatDec), LineColor
                   Else
                    MapFrm!Map1.Line -(LonDec, LatDec), LineColor
                    MapFrm!Pic1.Line -(LonDec, LatDec), LineColor
                   End If
                   FirstTime = False
                 Case 4
                   LineColor = QBColor(11)
                   If MapParam.MapRange <= 128 Then
                     If FirstTime Then
                       MapFrm!Map1.PSet (LonDec, LatDec), LineColor
                       MapFrm!Pic1.PSet (LonDec, LatDec), LineColor
                     Else
                       MapFrm!Map1.Line -(LonDec, LatDec), LineColor
                       MapFrm!Pic1.Line -(LonDec, LatDec), LineColor
                     End If
                     FirstTime = False
                   Else
                     If Atrib = 0 Then
                       If FirstTime Then
                         MapFrm!Map1.PSet (LonDec, LatDec), LineColor
                         MapFrm!Pic1.PSet (LonDec, LatDec), LineColor
                       Else
                         MapFrm!Map1.Line -(LonDec, LatDec), LineColor
                         MapFrm!Pic1.Line -(LonDec, LatDec), LineColor
                       End If
                       FirstTime = False
                     End If
                   End If
          End Select
        End If
      End If
    Next x
  Loop
  Close FileNumber
Return

End Sub

Public Sub ScaleMap()
Dim x As Integer
Dim sHold As String

MapFrm!Map1.Picture = LoadPicture()
MapFrm!Pic1.Picture = LoadPicture()


MapParam.RangeY = MapParam.MapRange / 60
MapParam.RangeX = 4 * MapParam.MapRange / (Cos(3.1416 * MapParam.LatCen / 180) * 3 * 60)
MapParam.LatMax = MapParam.LatCen + MapParam.RangeY
MapParam.LatMin = MapParam.LatCen - MapParam.RangeY
MapParam.LonMax = MapParam.LonCen + MapParam.RangeX
MapParam.LonMin = MapParam.LonCen - MapParam.RangeX
MapFrm!Map1.Scale (MapParam.LonMax, MapParam.LatMax)-(MapParam.LonMin, MapParam.LatMin)
MapFrm!Pic1.Scale (MapParam.LonMax, MapParam.LatMax)-(MapParam.LonMin, MapParam.LatMin)
If ScaleOnce Then
  For x = 0 To ConMdiFrm!ScaleCombo.ListCount - 1
    If MapParam.MapRange = Val(Mid(ConMdiFrm!ScaleCombo.List(x), InStr(ConMdiFrm!ScaleCombo.List(x), "=") + 2)) Then Exit For
  Next x
  If x = 14 Then
    x = 0
    MapParam.MapRange = 8000
  End If
  If MapParam.MapRange = Val(Mid(ConMdiFrm!ScaleCombo.Text, InStr(ConMdiFrm!ScaleCombo.Text, "=") + 2)) Then
    sHold = ConMdiFrm!ScaleCombo.List(x)
    ConMdiFrm!ScaleCombo.RemoveItem x
    ConMdiFrm!ScaleCombo.AddItem sHold, x
'    SameMapRange = True
'  Else
'    SameMapRange = False
  End If
  ConMdiFrm!ScaleCombo.ListIndex = x
End If

End Sub

Public Function DrwDosMap(sFilePath As String) As String
Dim FileNumber As Integer
Dim FirstTime As Boolean
Dim InRecord
Dim LatMax As Single
Dim LonMax As Single
Dim Ppd As Integer
Dim LatCen As Single
Dim LonCen As Single
Dim MapRadius As Integer
Dim MinRange As Integer
Dim MapType As String
Dim LatPoint As String
Dim LonPoint As String
Dim FeaColor As Integer
Dim I As Integer
Dim sBytes As String
Dim XYZ As String
Dim x As String
Dim y As String
Dim z As String
Dim zx As Integer
Dim zy As Integer
Dim XX As Integer
Dim YY As Integer
Dim sini As String

Dim LatDec As Single
Dim LonDec As Single
Dim LineColor As Long
Dim OldPointer As Integer

FileNumber = FreeFile
OldPointer = MapFrm!Map1.MousePointer
MapFrm!Map1.MousePointer = vbHourglass

sini = Dir(sFilePath)
If sini = "" Then
  DrwDosMap = ""
  Exit Function
End If

Open sFilePath For Input As FileNumber
Input #FileNumber, LatMax
Line Input #FileNumber, InRecord
Input #FileNumber, LonMax
Line Input #FileNumber, InRecord
Input #FileNumber, Ppd
Line Input #FileNumber, InRecord
Input #FileNumber, LatCen
Line Input #FileNumber, InRecord
Input #FileNumber, LonCen
Line Input #FileNumber, InRecord
Input #FileNumber, MapRadius
Line Input #FileNumber, InRecord
Input #FileNumber, MinRange
Line Input #FileNumber, InRecord
Input #FileNumber, MapType

If MapType <> "ASCII" And MapType <> "LineFormat" Then
  MsgBox "APRS-SCS will only work with ASCII and Line Format APRSdos maps. The type of this map is " & MapType & " Which is not supported.", vbInformation
  DrwDosMap = ""
  MapFrm!Map1.MousePointer = OldPointer
  Exit Function
End If

If MapType = "ASCII" Then
  Input #FileNumber, LonPoint, LatPoint
  Do
    If LonPoint = "0" And LatPoint = "0" Then
      FirstTime = True
      Input #FileNumber, FeaColor, InRecord
      Do
        Input #FileNumber, LonPoint, LatPoint
        If LonPoint = "0" And LatPoint = "-1" Then Exit Do
        If LonPoint <> "0" And LatPoint <> "0" Then
          LineColor = QBColor(FeaColor)
          LonDec = LonMax - (Val(LonPoint) / Ppd)
          LatDec = LatMax - (Val(LatPoint) / Ppd)
          GoSub PlotPoint
        End If
      Loop Until LonPoint = "0" And LatPoint = "0"
    End If
  Loop Until LonPoint = "0" And LatPoint = "-1"
Else
  Do
    Input #FileNumber, FeaColor
    If FeaColor = -1 Then Exit Do  'end of features data
    FirstTime = True
    Line Input #FileNumber, sBytes
        'at this point L$ contains a full feature of many 3 byte points
        'The next FOR-NEXT loop parses this L$ string 3 bytes at a time
    For I = 1 To Len(sBytes) Step 3
      'I = I + 1
      XYZ = Mid$(sBytes, I, 3) 'this gets each 3 bytes at a time
            'lets call each 3 bytes as XYZ (all printable 7 bit ascii)
            'where X is the MSBits of X and Y is the MSBits of Y
            'and Z contains the LSBits of both = .xxxxyyy
            'So the final value of Xx is 16*X + xxxx  and
            'the final value of Yy is 8*Y +yyy
      x = Left$(XYZ, 1)
      y = Mid$(XYZ, 2, 1)
      z = Right$(XYZ, 1)  'extract the "Z" byte
            'Each of these bytes has been bumped up into printable
            'ASCII by having had 27 added to them during compression
      zx = Int((Asc(z) - 27) / 8) 'extracts the X portion of Z$
      zy = (Asc(z) - 27) - zx * 8 'extracts the Y portion of Z$
      XX = 16 * (Asc(x) - 27) + zx
      YY = 8 * (Asc(y) - 27) + zy
            'at this point you have the same X,Y values of a normal DOSmap
      LineColor = QBColor(FeaColor)
      LonDec = LonMax - (XX / Ppd)
      LatDec = LatMax - (YY / Ppd)
      GoSub PlotPoint
    Next
  Loop
End If

Close FileNumber
MapFrm!Map1.MousePointer = OldPointer
MapFrm!Map1.Picture = MapFrm!Pic1.Image
If SIDrawSym Then Call ReDrawSymS
SIDrawSym = True
DrwDosMap = "AOK"
Exit Function

PlotPoint:
          If LatDec < MapParam.LatMax And LatDec > MapParam.LatMin Then
            If LonDec < MapParam.LonMax And LonDec > MapParam.LonMin Then
              If FirstTime Then
                MapFrm!Map1.PSet (LonDec, LatDec), LineColor
                MapFrm!Pic1.PSet (LonDec, LatDec), LineColor
              Else
                MapFrm!Map1.Line -(LonDec, LatDec), LineColor
                MapFrm!Pic1.Line -(LonDec, LatDec), LineColor
              End If
              FirstTime = False
            End If
          End If
Return
End Function

Public Function PicDosMap() As String
Dim FileNumber As Integer
Dim x As Long
Dim JunkIn As String
Dim sMapFile As String
Dim MapLatCen As Single
Dim MapLonCen As Single
Dim MapRange As Integer
Dim sini As String
Dim Spath As String
Dim RecIndex(12, 1) As Long '1,0 = fRangeRecNum     1,1 = rNumofMaps
Dim MapListData As FileFormatD
Dim y As Integer
Dim z As Integer
Dim sMapFileName()
Dim XX As Single
Dim YY As Single
Dim D As Single
Dim sEndit As Boolean

Spath = App.Path + "\dosmaps\"
If MapParam.MapRange >= 4096 Then
  sini = Dir(Spath + "world.map")
  If sini = "" Then
    MsgBox "The Dos map file world.map is not found. APRS-SCS will now try to display the usa.map at 1024 map range. If you want to continue to use APRS-SCS with Dos Maps then please go to www.tapr.org/~kb2scs and down load the dosmap.zip file. Then follow the web page instructions for installing the zip file.", vbInformation
    sini = Dir(App.Path + "\dosmaps\usa.map")
    If sini = "" Then
      MsgBox "usa.map is not found. APRS-SCS will now close when you click on the ok button. If you want to continue to use APRS-SCS with Dos Maps then please go to www.tapr.org/~kb2scs and down load the dosmap.zip file. Then follow the web page instructions for installing the zip file.", vbCritical
      Call EndMe
      Exit Function
    End If
    MapParam.LatCen = 38 + 32 / 60
    MapParam.LonCen = 95 + 57 / 60
    MapParam.MapRange = 1024
    MapParam.OldLatCen = MapParam.LatCen
    MapParam.OldLonCen = MapParam.LonCen
    MapParam.OldRange = MapParam.MapRange
    ScaleOnce = True
    Call ScaleMap
    PicDosMap = Spath + "USA.Map"
  Else
    PicDosMap = Spath + "WORLD.MAP"
  End If
  Exit Function
End If

sini = Dir(App.Path + "\maplist\maplist1.scs")
If sini = "" Then
  MsgBox "The Dos Map Maplist file maplist1.scs is not found. APRS-SCS will now close when you click on the ok button. If you want to continue to use APRS-SCS with Dos Maps then please go to www.tapr.org/~kb2scs and down load the dosmap.zip file. Then follow the web page instructions for installing the zip file.", vbInformation
  Call EndMe
  Exit Function
End If

FileNumber = FreeFile
Open App.Path + "\Maplist\maplist1.scs" For Random As FileNumber Len = 23
For x = 1 To 12
  Get #FileNumber, , MapListRange
  RecIndex(x, 0) = Val(MapListRange.fRangeRecNum)
  RecIndex(x, 1) = Val(MapListRange.rNumOfMaps)
Next x
y = ConMdiFrm!ScaleCombo.ListIndex - 1 '2048 = listindex of 2
ReDim MapFileName(RecIndex(y, 0))
Get #FileNumber, RecIndex(y, 0), MapListData
z = 0
GoSub FILLARRAY
For x = 2 To RecIndex(y, 1)
  Get #FileNumber, , MapListData
  GoSub FILLARRAY
Next x

Close FileNumber
sEndit = False
Do
  D = sMapFileName(1, 1)
  For y = 2 To z
    If sMapFileName(y, 1) < D Then
      sMapFileName(1, 0) = sMapFileName(y, 0)
      sMapFileName(1, 1) = sMapFileName(y, 1)
      Exit For
    End If
  Next y
  If y = z Then sEndit = True
Loop Until sEndit = True

PicDosMap = Spath + sMapFileName(1, 0)
Exit Function

FILLARRAY:
  z = z + 1
  sMapFileName(z, 0) = MapListData.MapFileName
  If Abs(MapParam.LatCen) >= Val(MapListData.CenLatDeg) + Val("." + MapListData.CenLatDec) Then
    If MapListData.CenLatHemi = "S" Then
      YY = MapParam.LatCen - ((Val(MapListData.CenLatDeg) + Val("." + MapListData.CenLatDec)) * -1)
    Else
      YY = MapParam.LatCen - (Val(MapListData.CenLatDeg) + Val("." + MapListData.CenLatDec))
    End If
  Else
    If MapListData.CenLatHemi = "S" Then
      YY = ((Val(MapListData.CenLatDeg) + Val("." + MapListData.CenLatDec)) * -1) - MapParam.LatCen
    Else
      YY = (Val(MapListData.CenLatDeg) + Val("." + MapListData.CenLatDec)) - MapParam.LatCen
    End If
  End If
  
  If Abs(MapParam.LonCen) >= Val(MapListData.CenLonDeg) + Val("." + MapListData.CenLonDec) Then
    If MapListData.CenLatHemi = "E" Then
      XX = MapParam.LonCen - ((Val(MapListData.CenLonDeg) + Val("." + MapListData.CenLonDec)) * -1)
    Else
      XX = MapParam.LonCen - (Val(MapListData.CenLonDeg) + Val("." + MapListData.CenLonDec))
    End If
  Else
    If MapListData.CenLonHemi = "E" Then
      XX = ((Val(MapListData.CenLonDeg) + Val("." + MapListData.CenLonDec)) * -1) - MapParam.LonCen
    Else
      XX = (Val(MapListData.CenLonDeg) + Val("." + MapListData.CenLonDec)) - MapParam.LonCen
    End If
  End If
  XX = Abs(XX)
  YY = Abs(YY)
  sMapFileName(z, 1) = Sqr((XX * XX) + (YY * YY))
Return

End Function
