Attribute VB_Name = "MapBas"
Option Explicit

Public Type FileFormatA
            LineID As String * 7
            ArtibCodeMin As String * 2
            NumPts As String * 6
            AtribCodeMaj As String * 5
End Type
Public Record1 As FileFormatA

Public Type FileFormatB
            LatDeg As String * 2
            LatMinute As String * 2
            LatSec As String * 2
            LatHemi As String * 1
            LonDeg As String * 3
            LonMinute As String * 2
            LonSec As String * 2
            LonHemi As String * 1
            SeqCount As String * 5
End Type
Public Record2 As FileFormatB

Public Type FileFormatC
            fRangeRecNum As String * 13 'First 12 records in file. One record for each
            rNumOfMaps As String * 10   'map range from 2048 to 1 mile map range
End Type
Public MapListRange As FileFormatC

Public Type FileFormatD
            MapFileName As String * 8
            CenLatDeg As String * 2
            CenLatDec As String * 4
            CenLatHemi As String * 1
            CenLonDeg As String * 3
            CenLonDec As String * 4
            CenLonHemi As String * 1
End Type

Public Type StuffMap
            MapRange As Double
            OldRange As Double
            LatCen As Single
            LonCen As Single
            OldLatCen As Single
            OldLonCen As Single
            LatMax As Single
            LatMin As Single
            LonMax As Single
            LonMin As Single
            RangeY As Single
            RangeX As Single
End Type
Public MapParam As StuffMap


Public Type LSec
            SecLonMax As Single
            SecLatMax As Single
            SecLonMin As Single
            SecLatMin As Single
End Type

Public LSecGrid(21) As LSec

Public Type Apt
            x As Single
            Y As Single
End Type

Public AnchorPT As Apt

Public Type JohnData1
            LatDec As Single
            LonDec As Single
            Scolor As Long
            Scallsign As String
            DisPlaySym As Boolean
            SymFile As String
End Type

Public SymLoc(32000) As JohnData1

Public ReckFlag As Boolean
Public MouseDragFlag As Boolean
Public LoadFlag As Boolean
Public SymIndex As Integer
Public SIDrawSym As Boolean
Public ScaleOnce As Boolean
'Public SameMapRange As Boolean

Public Sub DrawMap()
Dim x As Integer
Dim FirstTime As Boolean
Dim Y As Integer
Dim LatDec As Single
Dim LonDec As Single
Dim LineColor As Long
Dim SfileEnd(4) As String
Dim SfileBeg(21) As String
Dim FileOpenStart As Integer
Dim FileOpenEnd As Integer
Dim W As Integer
Dim OldPointer As Integer
Dim HoldValue As Integer
Dim FileNumber As Integer
Dim RecIn As String
Dim DegHold As String
Dim DecHold As String


SfileEnd(1) = "PB"
SfileEnd(2) = "RDI"
SfileEnd(3) = "RDL"
SfileEnd(4) = "WB"

SfileBeg(1) = "S01_"
SfileBeg(2) = "S02_"
SfileBeg(3) = "S03_"
SfileBeg(4) = "S04_"
SfileBeg(5) = "S05_"
SfileBeg(6) = "S06_"
SfileBeg(7) = "S07_"
SfileBeg(8) = "S08_"
SfileBeg(9) = "S09_"
SfileBeg(10) = "S10_"
SfileBeg(11) = "S11_"
SfileBeg(12) = "S12_"
SfileBeg(13) = "S13_"
SfileBeg(14) = "S14_"
SfileBeg(15) = "S15_"
SfileBeg(16) = "S16_"
SfileBeg(17) = "S17_"
SfileBeg(18) = "S18_"
SfileBeg(19) = "S19_"
SfileBeg(20) = "S20_"
SfileBeg(21) = "S21_"


FileOpenEnd = 0
FileOpenStart = 0
OldPointer = MapFrm!Map1.MousePointer
MapFrm!Map1.MousePointer = vbHourglass

For W = 1 To 15
  If LSecGrid(W).SecLatMax >= MapParam.LatMax And LSecGrid(W).SecLonMax >= MapParam.LonMax And LSecGrid(W).SecLatMin <= MapParam.LatMax And LSecGrid(W).SecLonMin <= MapParam.LonMax Then
    FileOpenEnd = W
  End If
Next W

For W = 1 To 15
  If LSecGrid(W).SecLatMax >= MapParam.LatMin And LSecGrid(W).SecLonMax >= MapParam.LonMin And LSecGrid(W).SecLatMin <= MapParam.LatMin And LSecGrid(W).SecLonMin <= MapParam.LonMin Then
    FileOpenStart = W
    Exit For
  End If
Next W
  
If FileOpenStart = 0 Then
  For W = 1 To 15
    If LSecGrid(W).SecLatMax >= MapParam.LatCen And LSecGrid(W).SecLonMax >= MapParam.LonCen And LSecGrid(W).SecLatMin <= MapParam.LatCen And LSecGrid(W).SecLonMin <= MapParam.LonCen Then
      Exit For
    End If
  Next W
  If MapParam.MapRange <= 64 Then FileOpenStart = W
End If
  
  
If FileOpenEnd > 0 And FileOpenStart > 0 And FileOpenEnd < FileOpenStart Then
  HoldValue = FileOpenStart
  FileOpenStart = FileOpenEnd
  FileOpenEnd = HoldValue
End If

If FileOpenEnd = 0 And FileOpenStart = 0 Then
  FileOpenEnd = 15
  FileOpenStart = 1
Else
  If FileOpenEnd = 0 Then
    Select Case FileOpenStart
           Case 1, 2, 3, 4
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenEnd = FileOpenStart
                    Case 32, 64, 128
                      FileOpenEnd = 7
                    Case 256, 512
                      FileOpenEnd = 11
                    Case Else
                      FileOpenEnd = 15
             End Select
           Case 5, 6, 7
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenEnd = FileOpenStart
                    Case 32, 64, 128
                      FileOpenEnd = 11
                    Case Else
                      FileOpenEnd = 15
             End Select
           Case 8, 9, 10, 11
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenEnd = FileOpenStart
                    Case Else
                      FileOpenEnd = 15
             End Select
           Case 12, 13, 14, 15
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenEnd = FileOpenStart
                    Case Else
                      FileOpenStart = 1
                      FileOpenEnd = 15
             End Select
    End Select
  End If
  If FileOpenStart = 0 Then
    Select Case FileOpenEnd
           Case 1, 2, 3, 4
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16, 32
                      FileOpenStart = FileOpenEnd
                      
                    Case 64, 128
                      FileOpenStart = FileOpenEnd
                      FileOpenEnd = 7
                    Case 256, 512
                      FileOpenStart = FileOpenEnd
                      FileOpenEnd = 11
                    Case Else
                      FileOpenStart = FileOpenEnd
                      FileOpenEnd = 15
             End Select
           
           Case 5, 6, 7
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenStart = FileOpenEnd
                    Case 32, 64, 128
                      FileOpenStart = 1
                    Case Else
                      FileOpenEnd = 15
                      FileOpenStart = 1
             End Select
           Case 8, 9, 10, 11
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenStart = FileOpenEnd
                    Case Else
                      FileOpenEnd = 15
                      FileOpenStart = 1
             End Select
           Case 12, 13, 14, 15
             Select Case MapParam.MapRange
                    Case 2, 4, 8, 16
                      FileOpenStart = FileOpenEnd
                    Case Else
                      FileOpenStart = 1
                      FileOpenEnd = 15
             End Select
    End Select
  End If
End If
  
FileNumber = FreeFile
For W = FileOpenStart To FileOpenEnd
  Select Case MapParam.MapRange
         Case Is < 32
           Y = 2
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(Y) + ".GRF" For Input As FileNumber
           GoSub READFILE
           Y = 3
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(Y) + ".GRF" For Input As FileNumber
           GoSub READFILE
           Y = 4
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(Y) + ".GRF" For Input As FileNumber
           GoSub READFILE
         Case Is >= 32
           Y = 1
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(Y) + ".GRF" For Input As FileNumber
           GoSub READFILE
           Y = 2
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(Y) + ".GRF" For Input As FileNumber
           GoSub READFILE
           Y = 4
           Open App.Path + "\Mapdata\" + SfileBeg(W) + SfileEnd(Y) + ".GRF" For Input As FileNumber
           GoSub READFILE
  End Select
Next W

MapFrm!Map1.MousePointer = OldPointer
MapFrm!Map1.Picture = MapFrm!Pic1.Image
If SIDrawSym Then Call ReDrawSymS
SIDrawSym = True
 
Exit Sub

READFILE:
  Do Until EOF(FileNumber)
'    If EOF(FileNumber) Then Exit Do
    FirstTime = True
    Input #FileNumber, RecIn
      LineColor = QBColor(Val(Mid(RecIn, 1, 1)))
    x = 2
    Do
      DegHold = Mid(RecIn, x, 3)
      x = x + 3 '5
      DecHold = Mid(RecIn, x, 4)
      LonDec = Val(DegHold) + Val("." + DecHold)
      x = x + 4 '9
      If Mid(RecIn, x, 1) = "E" Then LonDec = LonDec * -1
      x = x + 1 '10
      DegHold = Mid(RecIn, x, 2)
      x = x + 2 '12
      DecHold = Mid(RecIn, x, 4)
      LatDec = Val(DegHold) + Val("." + DecHold)
      x = x + 4 '16
      If Mid(RecIn, x, 1) = "S" Then LatDec = LatDec * -1
      x = x + 1 '17
      If LatDec < MapParam.LatMax And LatDec > MapParam.LatMin Then
        If LonDec < MapParam.LonMax And LonDec > MapParam.LonMin Then
          If FirstTime Then
            MapFrm!Map1.PSet (LonDec, LatDec), LineColor
            MapFrm!Pic1.PSet (LonDec, LatDec), LineColor
          Else
            MapFrm!Map1.Line -(LonDec, LatDec), LineColor
            MapFrm!Pic1.Line -(LonDec, LatDec), LineColor
          End If
          FirstTime = False
        End If
      End If
    Loop Until x >= Len(RecIn)
  Loop
  Close FileNumber
Return

End Sub

Public Sub ScaleMap()
Dim x As Integer
Dim Shold As String

MapFrm!Map1.Picture = LoadPicture()
MapFrm!Pic1.Picture = LoadPicture()


MapParam.RangeY = MapParam.MapRange / 60
MapParam.RangeX = 4 * MapParam.MapRange / (Cos(3.1416 * MapParam.LatCen / 180) * 3 * 60)
MapParam.LatMax = MapParam.LatCen + MapParam.RangeY
MapParam.LatMin = MapParam.LatCen - MapParam.RangeY
MapParam.LonMax = MapParam.LonCen + MapParam.RangeX
MapParam.LonMin = MapParam.LonCen - MapParam.RangeX
MapFrm!Map1.Scale (MapParam.LonMax, MapParam.LatMax)-(MapParam.LonMin, MapParam.LatMin)
MapFrm!Pic1.Scale (MapParam.LonMax, MapParam.LatMax)-(MapParam.LonMin, MapParam.LatMin)
If ScaleOnce Then
  For x = 0 To ConMdiFrm!ScaleCombo.ListCount - 1
    If MapParam.MapRange = Val(Mid(ConMdiFrm!ScaleCombo.List(x), InStr(ConMdiFrm!ScaleCombo.List(x), "=") + 2)) Then Exit For
  Next x
  If x = 14 Then
    x = 0
    MapParam.MapRange = 8000
  End If
  If MapParam.MapRange = Val(Mid(ConMdiFrm!ScaleCombo.Text, InStr(ConMdiFrm!ScaleCombo.Text, "=") + 2)) Then
    Shold = ConMdiFrm!ScaleCombo.List(x)
    ConMdiFrm!ScaleCombo.RemoveItem x
    ConMdiFrm!ScaleCombo.AddItem Shold, x
'    SameMapRange = True
'  Else
'    SameMapRange = False
  End If
  ConMdiFrm!ScaleCombo.ListIndex = x
End If

End Sub

Public Function DrwDosMap(SfilePath As String) As String
Dim FileNumber As Integer
Dim FirstTime As Boolean
Dim InRecord
Dim LatMax As Single
Dim LonMax As Single
Dim Ppd As Long
Dim LatCen As Single
Dim LonCen As Single
Dim MapRadius As Integer
Dim MinRange As Integer
Dim MapType As String
Dim LatPoint As String
Dim LonPoint As String
Dim FeaColor As Integer
Dim I As Integer
Dim sBytes As String
Dim XYZ As String
Dim x As String
Dim Y As String
Dim z As String
Dim zx As Integer
Dim zy As Integer
Dim xx As Integer
Dim YY As Integer
Dim sini As String
Dim MapFileName As String

Dim LatDec As Single
Dim LonDec As Single
Dim LineColor As Long

FileNumber = FreeFile

sini = Dir(SfilePath)
If sini = "" Then
  DrwDosMap = ""
  Exit Function
End If

MapFileName = Right(SfilePath, 12)
If InStr(MapFileName, "\") <> 0 Then MapFileName = Mid(MapFileName, InStr(MapFileName, "\") + 1)
ConMdiFrm!dMapTxt.Text = MapFileName
Open SfilePath For Input As FileNumber
Input #FileNumber, LatMax
Line Input #FileNumber, InRecord
Input #FileNumber, LonMax
Line Input #FileNumber, InRecord
Input #FileNumber, Ppd
Line Input #FileNumber, InRecord
Input #FileNumber, LatCen
Line Input #FileNumber, InRecord
Input #FileNumber, LonCen
Line Input #FileNumber, InRecord
Input #FileNumber, MapRadius
Line Input #FileNumber, InRecord
Input #FileNumber, MinRange
Line Input #FileNumber, InRecord
Input #FileNumber, MapType

If MapType <> "ASCII" And MapType <> "LineFormat" Then
  MsgBox "APRS-SCS will only work with ASCII and Line Format APRSdos maps. The type of this map is " & MapType & " Which is not supported.", vbInformation
  DrwDosMap = ""
  Close FileNumber
  Exit Function
End If

On Error GoTo HANDLELER

If MapType = "ASCII" Then
  Input #FileNumber, LonPoint, LatPoint
  Do
    If LonPoint = "0" And LatPoint = "0" Then
      FirstTime = True
      Input #FileNumber, FeaColor
      Line Input #FileNumber, InRecord
      Do
        Input #FileNumber, LonPoint, LatPoint
        If LonPoint = "0" And LatPoint = "-1" Then Exit Do
        If LonPoint <> "0" And LatPoint <> "0" Then
          LineColor = QBColor(FeaColor)
          LonDec = LonMax - (Val(LonPoint) / Ppd)
          LatDec = LatMax - (Val(LatPoint) / Ppd)
          GoSub PlotPoint
        End If
      Loop Until LonPoint = "0" And LatPoint = "0"
    End If
  Loop Until LonPoint = "0" And LatPoint = "-1"
Else
  Do
    Input #FileNumber, FeaColor
    If FeaColor = -1 Then Exit Do  'end of features data
    FirstTime = True
    Line Input #FileNumber, sBytes
        'at this point L$ contains a full feature of many 3 byte points
        'The next FOR-NEXT loop parses this L$ string 3 bytes at a time
    For I = 1 To Len(sBytes) Step 3
      'I = I + 1
      XYZ = Mid$(sBytes, I, 3) 'this gets each 3 bytes at a time
            'lets call each 3 bytes as XYZ (all printable 7 bit ascii)
            'where X is the MSBits of X and Y is the MSBits of Y
            'and Z contains the LSBits of both = .xxxxyyy
            'So the final value of Xx is 16*X + xxxx  and
            'the final value of Yy is 8*Y +yyy
      x = Left$(XYZ, 1)
      Y = Mid$(XYZ, 2, 1)
      z = Right$(XYZ, 1)  'extract the "Z" byte
            'Each of these bytes has been bumped up into printable
            'ASCII by having had 27 added to them during compression
      zx = Int((Asc(z) - 27) / 8) 'extracts the X portion of Z$
      zy = (Asc(z) - 27) - zx * 8 'extracts the Y portion of Z$
      xx = 16 * (Asc(x) - 27) + zx
      YY = 8 * (Asc(Y) - 27) + zy
            'at this point you have the same X,Y values of a normal DOSmap
      LineColor = QBColor(FeaColor)
      LonDec = LonMax - (xx / Ppd)
      LatDec = LatMax - (YY / Ppd)
      GoSub PlotPoint
    Next
  Loop
End If

Close FileNumber
MapFrm!Map1.Picture = MapFrm!Pic1.Image
If SIDrawSym Then Call ReDrawSymS
SIDrawSym = True
DrwDosMap = "AOK"
Exit Function

PlotPoint:
'          If LatDec < MapParam.LatMax And LatDec > MapParam.LatMin Then
'            If LonDec < MapParam.LonMax And LonDec > MapParam.LonMin Then
              If FirstTime Then
                MapFrm!Map1.PSet (LonDec, LatDec), LineColor
                MapFrm!Pic1.PSet (LonDec, LatDec), LineColor
              Else
                MapFrm!Map1.Line -(LonDec, LatDec), LineColor
                MapFrm!Pic1.Line -(LonDec, LatDec), LineColor
              End If
              FirstTime = False
 '           End If
'          End If
Return

Exit Function
HANDLELER:
           Close FileNumber
           DrwDosMap = "ERROR"
           On Error GoTo 0
End Function

Public Function PicDosMap() As String
Dim FileNumber As Integer
Dim x As Long
Dim JunkIn As String
Dim sMapFile As String
Dim MapLatCen As Single
Dim MapLonCen As Single
Dim MapRange As Integer
Dim sini As String
Dim Spath As String
Dim RecIndex(12, 1) As Long '1,0 = fRangeRecNum     1,1 = rNumofMaps
Dim MapListData As FileFormatD
Dim Y As Integer
Dim z As Integer
Dim xx As Single
Dim YY As Single
Dim D As Single
Dim sEndit As Boolean
Dim sMapFileName()

Spath = App.Path + "\dosmaps\"
If MapParam.MapRange >= 4096 Then
  sini = Dir(Spath + "world.map")
  If sini = "" Then
    MsgBox "The Dos map file world.map is not found. APRS-SCS will now try to display the usa.map at 1024 map range. If you want to continue to use APRS-SCS with Dos Maps then please go to www.tapr.org/~kb2scs and down load the dosmap.zip file. Then follow the web page instructions for installing the zip file.", vbInformation
    sini = Dir(App.Path + "\dosmaps\usa.map")
    If sini = "" Then
      MsgBox "usa.map is not found. APRS-SCS will now close when you click on the ok button. If you want to continue to use APRS-SCS with Dos Maps then please go to www.tapr.org/~kb2scs and down load the dosmap.zip file. Then follow the web page instructions for installing the zip file.", vbCritical
      Call EndMe
      Exit Function
    End If
    MapParam.LatCen = 38 + 32 / 60
    MapParam.LonCen = 95 + 57 / 60
    MapParam.MapRange = 1024
    MapParam.OldLatCen = MapParam.LatCen
    MapParam.OldLonCen = MapParam.LonCen
    MapParam.OldRange = MapParam.MapRange
    ScaleOnce = True
    Call ScaleMap
    PicDosMap = Spath + "USA.Map"
  Else
    PicDosMap = Spath + "WORLD.MAP"
  End If
  Exit Function
End If

sini = Dir(App.Path + "\maplist\maplist1.scs")
If sini = "" Then
  MsgBox "The Dos Map Maplist file maplist1.scs is not found. APRS-SCS will now close when you click on the ok button. If you want to continue to use APRS-SCS with Dos Maps then please go to www.tapr.org/~kb2scs and down load the dosmap.zip file. Then follow the web page instructions for installing the zip file.", vbInformation
  Call EndMe
  Exit Function
End If

FileNumber = FreeFile
Open App.Path + "\Maplist\maplist1.scs" For Random As FileNumber Len = 23
For x = 1 To 12
  Get #FileNumber, , MapListRange
  RecIndex(x, 0) = Val(MapListRange.fRangeRecNum)
  RecIndex(x, 1) = Val(MapListRange.rNumOfMaps)
Next x
Y = ConMdiFrm!ScaleCombo.ListIndex - 1 '2048 = listindex of 2
ReDim sMapFileName(RecIndex(Y, 1), 1)
Get #FileNumber, RecIndex(Y, 0), MapListData
z = 0
GoSub FILLARRAY
If RecIndex(Y, 1) > 1 Then
  For x = 2 To RecIndex(Y, 1)
    Get #FileNumber, , MapListData
    GoSub FILLARRAY
  Next x

  sEndit = False
  Do
    D = sMapFileName(1, 1)
    For Y = 2 To z
      If sMapFileName(Y, 1) < D Then
        sMapFileName(1, 0) = sMapFileName(Y, 0)
        sMapFileName(1, 1) = sMapFileName(Y, 1)
        Exit For
      End If
    Next Y
    If Y = z + 1 Then sEndit = True
  Loop Until sEndit = True
End If

Close FileNumber
PicDosMap = Spath + sMapFileName(1, 0) + ".map"
Exit Function

FILLARRAY:
  z = z + 1
  sMapFileName(z, 0) = RTrim(MapListData.MapFileName)
  If Abs(MapParam.LatCen) >= Val(MapListData.CenLatDeg) + Val("." + MapListData.CenLatDec) Then
    If MapListData.CenLatHemi = "S" Then
      YY = MapParam.LatCen - ((Val(MapListData.CenLatDeg) + Val("." + MapListData.CenLatDec)) * -1)
    Else
      YY = MapParam.LatCen - (Val(MapListData.CenLatDeg) + Val("." + MapListData.CenLatDec))
    End If
  Else
    If MapListData.CenLatHemi = "S" Then
      YY = ((Val(MapListData.CenLatDeg) + Val("." + MapListData.CenLatDec)) * -1) - MapParam.LatCen
    Else
      YY = (Val(MapListData.CenLatDeg) + Val("." + MapListData.CenLatDec)) - MapParam.LatCen
    End If
  End If
  
  If Abs(MapParam.LonCen) >= Val(MapListData.CenLonDeg) + Val("." + MapListData.CenLonDec) Then
    If MapListData.CenLatHemi = "E" Then
      xx = MapParam.LonCen - ((Val(MapListData.CenLonDeg) + Val("." + MapListData.CenLonDec)) * -1)
    Else
      xx = MapParam.LonCen - (Val(MapListData.CenLonDeg) + Val("." + MapListData.CenLonDec))
    End If
  Else
    If MapListData.CenLonHemi = "E" Then
      xx = ((Val(MapListData.CenLonDeg) + Val("." + MapListData.CenLonDec)) * -1) - MapParam.LonCen
    Else
      xx = (Val(MapListData.CenLonDeg) + Val("." + MapListData.CenLonDec)) - MapParam.LonCen
    End If
  End If
  xx = Abs(xx)
  YY = Abs(YY)
  sMapFileName(z, 1) = Sqr((xx * xx) + (YY * YY))
Return

End Function

Public Sub ViewMap(SfilePath As String)
Dim PicRatio As Double
Dim printerWidth As Double
Dim printerHeight As Double
Dim printerRatio As Double
Dim printerPicWidth As Double
Dim printerPicHeight As Double
  
Set MapFrm!Pic1.Picture = LoadPicture(SfilePath)
' Calculate device independent Width-to-Height ratio for picture.
PicRatio = MapFrm!Pic1.Width / MapFrm!Pic1.Height
' Calculate the dimentions of the printable area in HiMetric.
printerWidth = MapFrm!Map1.ScaleX(MapFrm!Map1.ScaleWidth, MapFrm!Map1.ScaleMode, vbHimetric)
printerHeight = MapFrm!Map1.ScaleY(MapFrm!Map1.ScaleHeight, MapFrm!Map1.ScaleMode, vbHimetric)
' Calculate device independent Width to Height ratio for printer.
printerRatio = printerWidth / printerHeight
' Scale the output to the printable area.
If PicRatio >= printerRatio Then
  ' Scale picture to fit full width of printable area.
  printerPicWidth = MapFrm!Map1.ScaleX(printerWidth, vbHimetric, MapFrm!Map1.ScaleMode)
  printerPicHeight = MapFrm!Map1.ScaleY(printerWidth / PicRatio, vbHimetric, MapFrm!Map1.ScaleMode)
Else
  ' Scale picture to fit full height of printable area.
  printerPicHeight = MapFrm!Map1.ScaleY(printerHeight, vbHimetric, MapFrm!Map1.ScaleMode)
  printerPicWidth = MapFrm!Map1.ScaleX(printerHeight * PicRatio, vbHimetric, MapFrm!Map1.ScaleMode)
End If
' Print the picture using the PaintPicture method.
MapFrm!Map1.PaintPicture MapFrm!Pic1.Picture, 0, 0, printerPicWidth, printerPicHeight

End Sub

Public Sub DrawBitMap()
Dim FileNumber As Integer
Dim BitMapRange As Double
Dim TopY As Double
Dim LeftX As Double
Dim BotY As Double
Dim RightX As Double
Dim x As Integer
Dim SfilePath As String
Dim Sfile As String
Dim UiLat As String
Dim UiLatDeg As String
Dim UiLatDecMin As String
Dim UiLong As String
Dim UiLongDeg As String
Dim UiLongDecMin As String
Dim sHemi As String
Dim sini As String
Dim Sext(2) As String

On Error GoTo ERRORFIX
Sext(0) = ".TXT"
Sext(1) = ".INF"
Sext(2) = ".TXT or .INF"

SfilePath = App.Path & "\bitmap\" & ConMdiFrm!BitMapCombo.List(ConMdiFrm!BitMapCombo.ListIndex)
Sfile = Mid(ConMdiFrm!BitMapCombo.List(ConMdiFrm!BitMapCombo.ListIndex), 1, InStr(ConMdiFrm!BitMapCombo.List(ConMdiFrm!BitMapCombo.ListIndex), ".") - 1)

sini = ""
x = -1
Do Until sini <> ""
  x = x + 1
  If x = 2 Then Exit Do
  sini = Dir(App.Path + "\bitmap\" & Sfile & Sext(x))
Loop
If x = 2 Then
  MsgBox Sfile & " Is missing its " & Sext(x) & " file. To fix this error please copy the " & Sfile & Sext(x) & " file to the \aprsscs\bitmap sub-directory or remove " & Sfile & " from the \aprsscs\bitmap sub-directory.", vbCritical
  Exit Sub
End If

FileNumber = FreeFile

Open App.Path & "\bitmap\" & sini For Input As FileNumber

If x = 0 Then
  Input #FileNumber, TopY
  Input #FileNumber, LeftX
  Input #FileNumber, BotY
  Input #FileNumber, RightX
Else
  Input #FileNumber, UiLat, UiLong
  UiLatDeg = Mid(UiLat, 1, InStr(UiLat, ".") - 1)
  UiLatDecMin = Mid(UiLat, InStr(UiLat, ".") + 1)
  sHemi = Right(UiLat, 1)
  TopY = Val(UiLatDeg) + Val(UiLatDecMin) / 60
  If UCase(sHemi) = "S" Then TopY = TopY * -1
  
  UiLongDeg = Mid(UiLong, 1, InStr(UiLong, ".") - 1)
  UiLongDecMin = Mid(UiLong, InStr(UiLong, ".") + 1)
  sHemi = Right(UiLong, 1)
  LeftX = Val(UiLongDeg) + Val(UiLongDecMin) / 60
  If UCase(sHemi) = "W" Then LeftX = LeftX * -1
  
  Input #FileNumber, UiLat, UiLong
  UiLatDeg = Mid(UiLat, 1, InStr(UiLat, ".") - 1)
  UiLatDecMin = Mid(UiLat, InStr(UiLat, ".") + 1)
  sHemi = Right(UiLat, 1)
  BotY = Val(UiLatDeg) + Val(UiLatDecMin) / 60
  If UCase(sHemi) = "S" Then BotY = BotY * -1
  
  UiLongDeg = Mid(UiLong, 1, InStr(UiLong, ".") - 1)
  UiLongDecMin = Mid(UiLong, InStr(UiLong, ".") + 1)
  sHemi = Right(UiLong, 1)
  RightX = Val(UiLongDeg) + Val(UiLongDecMin) / 60
  If UCase(sHemi) = "W" Then RightX = RightX * -1
End If

Close FileNumber

LeftX = LeftX * -1
RightX = RightX * -1
MapParam.LatCen = (TopY + BotY) / 2
MapParam.LonCen = (LeftX + RightX) / 2
MapParam.LatMax = TopY
MapParam.LatMin = BotY
MapParam.LonMax = LeftX
MapParam.LonMin = RightX

If TopY < 1 Or BotY < 1 Then
  BitMapRange = Abs((TopY + BotY)) * 60
ElseIf TopY > BotY Then
  BitMapRange = Abs((TopY - BotY)) * 60
ElseIf BotY > TopY Then
  BitMapRange = Abs((BotY - TopY)) * 60
End If
BitMapRange = BitMapRange / 2

Select Case BitMapRange
       Case Is >= 6144
            MapParam.MapRange = 8192
       Case 3037 To 6143
            MapParam.MapRange = 4096
       Case 1537 To 3072
            MapParam.MapRange = 2048
       Case 768 To 1536
            MapParam.MapRange = 1024
       Case 384 To 767
            MapParam.MapRange = 512
       Case 192 To 510
            MapParam.MapRange = 256
       Case 96 To 191
            MapParam.MapRange = 128
       Case 48 To 95
            MapParam.MapRange = 64
       Case 24 To 47
            MapParam.MapRange = 32
       Case 12 To 23
            MapParam.MapRange = 16
       Case 6 To 11
            MapParam.MapRange = 8
       Case 3 To 5
            MapParam.MapRange = 4
       Case 1.5 To 2
            MapParam.MapRange = 2
       Case 0.75 To 1
            MapParam.MapRange = 1
       Case 0.375 To 0.74
            MapParam.MapRange = 0.5
       Case 0.1875 To 0.374
            MapParam.MapRange = 0.25
       Case 0.09375 To 0.1874
            MapParam.MapRange = 0.125
       Case Else
            MapParam.MapRange = 0.0625
End Select
ConMdiFrm!ScaleTxt.Text = ""
ConMdiFrm!ScaleTxt.Text = "Map Range = " & MapParam.MapRange
MapFrm!Map1.Picture = LoadPicture()
MapFrm!Pic1.Picture = LoadPicture()
MapFrm!Map1.AutoRedraw = True
MapFrm!Pic1.AutoRedraw = True
MapFrm!Map1.ScaleMode = 3
MapFrm!Pic1.ScaleMode = 3

Call ViewMap(SfilePath)
MapFrm!Map1.Scale (MapParam.LonMax, MapParam.LatMax)-(MapParam.LonMin, MapParam.LatMin)
MapFrm!Pic1.Scale (MapParam.LonMax, MapParam.LatMax)-(MapParam.LonMin, MapParam.LatMin)

If SIDrawSym Then Call ReDrawSymS
SIDrawSym = True
LoadFlag = False
Exit Sub
ERRORFIX:
          MsgBox Sfile & Sext(x) & " file is corrupt. To fix this error please edit the " & Sfile & Sext(x) & " file and fix the format error.", vbCritical
          Close FileNumber
          On Error GoTo 0
End Sub
