Attribute VB_Name = "Kiss"
Option Explicit

Public Function DecodeAX25(KissFrame As String) As String
Dim ToCall As String
Dim ToCallSsid As String
Dim FromCall As String
Dim FromCallSsid As String
Dim DigiCalls As String
Dim Xhold As Integer
Dim xCtrlCPos As Integer
Dim xPidCPos As Integer
Dim AprsPart As String
Dim xAstPos As Integer
Dim Zhold As Integer
Dim x As Integer
Dim Y As Integer
Dim z As Integer

xCtrlCPos = InStr(15, KissFrame, Chr$(3))
'debug.Print "03 byte position"; " "; xCtrlCPos
If xCtrlCPos = 0 Then
  DecodeAX25 = "NG"
  Exit Function
End If

If xCtrlCPos <> 15 Then
  Select Case xCtrlCPos
         Case 22, 29, 36, 43, 50, 57, 64, 71
           'xctrlcpos is correct do nothing
         Case Else
           DecodeAX25 = "NG"
           Exit Function
  End Select
End If

xPidCPos = InStr(16, KissFrame, Chr$(240))
'debug.Print "F0 byte position"; " "; xPidCPos
If xPidCPos = 0 Then
  DecodeAX25 = "NG"
  Exit Function
End If

If xPidCPos <> 16 Then
  Select Case xPidCPos
         Case 23, 30, 37, 44, 51, 58, 65, 72
           'xctrlcpos is correct do nothing
         Case Else
           DecodeAX25 = "NG"
           Exit Function
  End Select
End If


If InStr(KissFrame, Chr$(219)) <> 0 Then Call ReplFesc(KissFrame)

For x = 1 To 6
   ToCall = ToCall + Chr$(Asc(Mid(KissFrame, x, 1)) / 2)
Next x
ToCall = RTrim(ToCall)
Xhold = Asc(Mid(KissFrame, 7, 1))
'debug.Print "ToCall"; " "; Xhold
If Xhold > 127 Then Xhold = Xhold - 128
Xhold = (Xhold - 96) / 2
If Xhold > 0 Then ToCall = ToCall + "-" + LTrim(Str(Xhold))

For x = 8 To 13
   FromCall = FromCall + Chr$(Asc(Mid(KissFrame, x, 1)) / 2)
Next x
FromCall = RTrim(FromCall)
Xhold = Asc(Mid(KissFrame, 14, 1))
If xCtrlCPos = 15 Then Xhold = Xhold - 1
'debug.Print "Fromcall"; " "; Xhold
If Xhold > 127 Then Xhold = Xhold - 128
Xhold = (Xhold - 96) / 2
If Xhold > 0 Then FromCall = FromCall + "-" + LTrim(Str(Xhold))

x = 15
DigiCalls = ""
z = 0
If xCtrlCPos <> 15 Then
   Do
     DigiCalls = DigiCalls + ","
     For Y = x To x + 5
       DigiCalls = DigiCalls + Chr$(Asc(Mid(KissFrame, Y, 1)) / 2)
     Next Y
     DigiCalls = RTrim(DigiCalls)
     x = x + 6
     Xhold = Asc(Mid(KissFrame, x, 1))
     If xCtrlCPos = x + 1 Then Xhold = Xhold - 1
     'you have to check if 2 or more digi h bits are set
     'if so you have to only put the * on the last digi
     ' z=z+1 does this
     If Xhold > 127 Then
       z = z + 1
       Xhold = Xhold - 128
       Xhold = (Xhold - 96) / 2
       If Xhold > 0 Then
         DigiCalls = DigiCalls + "-" + LTrim(Str(Xhold)) + "*"
       Else
         DigiCalls = DigiCalls + "*"
       End If
     Else
       Xhold = (Xhold - 96) / 2
       If Xhold > 0 Then DigiCalls = DigiCalls + "-" + LTrim(Str(Xhold))
     End If
     x = x + 1
   Loop Until x = xCtrlCPos
End If
x = x + 2
AprsPart = ":"
AprsPart = AprsPart + Mid(KissFrame, x, (Len(KissFrame) - 2))
If DigiCalls = "" Then
  DecodeAX25 = FromCall + ">" + ToCall + AprsPart
Else
  Zhold = z
  If MyAlias = "WIDE1-1" Then Call KissDigiPeat(DigiCalls, z, MyAlias)
  If Zhold <> z Then Call SendPacket(ToCall, FromCall, Mid(DigiCalls, 2, Len(DigiCalls) - 1), Mid(AprsPart, 2, Len(AprsPart) - 1))
  Zhold = z
  Call KissDigiPeat(DigiCalls, z, MyCall)
  If Zhold <> z Then Call SendPacket(ToCall, FromCall, Mid(DigiCalls, 2, Len(DigiCalls) - 1), Mid(AprsPart, 2, Len(AprsPart) - 1))
  If z > 1 Then
    z = z - 1
    For x = 1 To z
      xAstPos = InStr(DigiCalls, "*")
      DigiCalls = Mid(DigiCalls, 1, xAstPos - 1) + Mid(DigiCalls, xAstPos + 1, (Len(DigiCalls) - xAstPos))
    Next x
  End If
  DecodeAX25 = FromCall + ">" + ToCall + DigiCalls + AprsPart
End If
End Function

Private Sub ReplFesc(KissFrame As String)
Dim x As Integer
Dim Shold As String

x = 0
Shold = ""

Do Until x = Len(KissFrame)
  x = x + 1
  If Mid(KissFrame, x, 1) = Chr$(219) Then
    x = x + 1
    If Mid(KissFrame, x, 1) = Chr$(220) Then Shold = Shold + Chr$(192)
    If Mid(KissFrame, x, 1) = Chr$(221) Then Shold = Shold + Chr$(219)
  Else
    Shold = Shold + Mid(KissFrame, x, 1)
  End If
Loop
KissFrame = Shold
End Sub

Public Sub SendPacket(OutToCall As String, OutFromCall As String, OutDigiCall As String, OutUserData As String, Optional WhPortSend As String)
Dim ToCallStr As String
Dim ToCallSsidByt As Byte
Dim FromCallStr As String
Dim FromCallSsidByt As Byte
Dim DigiCallStr(8) As String
Dim DigiCallByt(48) As Byte
Dim DigiCallSsidByt(8) As Byte
Dim Hbit(8) As String
Dim x As Integer
Dim Y As Integer
Dim z As Integer
Dim zz As Integer
Dim sPacketOut As String
Dim Shold As String
Dim Stemp As String
Dim xCommaPos As Integer
Dim DigiIn As String

If ConMdiFrm!PortTnc.Checked = False And ConMdiFrm!SoundSoc.Connected = False Then Exit Sub

DigiIn = OutDigiCall

sPacketOut = Chr$(192) + Chr$(0)

If InStr(OutToCall, "-") <> 0 Then
  ToCallSsidByt = (Val(Mid(OutToCall, InStr(OutToCall, "-") + 1, Len(OutToCall) - InStr(OutToCall, "-"))) * 2) + 96
  If ToCallSsidByt + 128 > 255 Then
    MsgBox "Your Destination SSID is greater than 15. This is not allowed. Please change your Destination SSID to be a number that is lower than 16.", vbCritical
    Exit Sub
  Else
    ToCallSsidByt = ToCallSsidByt + 128 'ax25 version 2 c bit set on tocall so ui frame is a command.
  End If
  ToCallStr = Mid(OutToCall, 1, InStr(OutToCall, "-") - 1)
Else
  ToCallSsidByt = 96 + 128
  ToCallStr = OutToCall
End If
If Len(ToCallStr) < 6 Then ToCallStr = ToCallStr + Space(6 - Len(ToCallStr))
If Len(ToCallStr) > 6 Then
  MsgBox "Your Destination Call Sign has more than 6 Characters. This is not allowed. Please change your Destination Call Sign to have no more than 6 Characters Max.", vbCritical
  Exit Sub
End If
For x = 1 To 6
  Shold = Chr$(Asc(Mid(ToCallStr, x, 1)) * 2)
  If Shold = Chr$(192) Then
    Shold = Chr$(219) + Chr$(220)
  Else
    If Shold = Chr$(219) Then Shold = Chr$(219) + Chr$(221)
  End If
  sPacketOut = sPacketOut + Shold
Next x
sPacketOut = sPacketOut + Chr$(ToCallSsidByt)

If InStr(OutFromCall, "-") <> 0 Then
  FromCallSsidByt = (Val(Mid(OutFromCall, InStr(OutFromCall, "-") + 1, Len(OutFromCall) - InStr(OutFromCall, "-"))) * 2) + 96
  If FromCallSsidByt + 128 > 255 Then
    MsgBox "Your MYCall SSID is greater than 15. This is not allowed. Please change your MYcall SSID to be a number that is lower than 16.", vbCritical
    Exit Sub
  End If
  FromCallStr = Mid(OutFromCall, 1, InStr(OutFromCall, "-") - 1)
Else
  FromCallSsidByt = 96
  FromCallStr = OutFromCall
End If
If Len(FromCallStr) < 6 Then FromCallStr = FromCallStr + Space(6 - Len(FromCallStr))
If Len(FromCallStr) > 6 Then
  MsgBox "Your MyCall Sign has more than 6 Characters. This is not allowed. Please change your MyCall Sign to have no more than 6 Characters Max.", vbCritical
  Exit Sub
End If
For x = 1 To 6
  Shold = Chr$(Asc(Mid(FromCallStr, x, 1)) * 2)
  If Shold = Chr$(192) Then
    Shold = Chr$(219) + Chr$(220)
  Else
    If Shold = Chr$(219) Then Shold = Chr$(219) + Chr$(221)
  End If
  sPacketOut = sPacketOut + Shold
Next x
    
x = 0
If DigiIn <> "" Then
  xCommaPos = InStr(DigiIn, ",")
  If xCommaPos = 0 Then
    DigiCallStr(1) = DigiIn
    If InStr(DigiCallStr(1), "*") <> 0 Then
      DigiCallStr(1) = Mid(DigiCallStr(1), 1, Len(DigiCallStr(1)) - 1)
      Hbit(1) = "*"
    End If
    x = 1
  Else
    Do
      If x = 8 Then
        MsgBox "You cannot have more than 8 Digipeater Call Signs. Please Reduce the number of Digipeaters.", vbCritical
        Exit Sub
      End If
      x = x + 1
      DigiCallStr(x) = Mid(DigiIn, 1, xCommaPos - 1)
      If InStr(DigiCallStr(x), "*") <> 0 Then
        DigiCallStr(x) = Mid(DigiCallStr(x), 1, Len(DigiCallStr(x)) - 1)
        Hbit(x) = "*"
      End If
      DigiIn = Mid(DigiIn, xCommaPos + 1, Len(DigiIn) - xCommaPos)
      xCommaPos = InStr(DigiIn, ",")
    Loop Until xCommaPos = 0
    If x = 8 Then
      MsgBox "You cannot have more than 8 Digipeater Call Signs. Please Reduce the number of Digipeaters.", vbCritical
      Exit Sub
    End If
    x = x + 1
    DigiCallStr(x) = DigiIn
    If InStr(DigiCallStr(x), "*") <> 0 Then
      DigiCallStr(x) = Mid(DigiCallStr(x), 1, Len(DigiCallStr(x)) - 1)
      Hbit(x) = "*"
    End If
  End If
  For Y = 1 To x
    If InStr(DigiCallStr(Y), "-") <> 0 Then
      DigiCallSsidByt(Y) = (Val(Mid(DigiCallStr(Y), InStr(DigiCallStr(Y), "-") + 1, Len(DigiCallStr(Y)) - InStr(DigiCallStr(Y), "-"))) * 2) + 96
      If DigiCallSsidByt(Y) + 128 > 255 Then
        MsgBox "One or more of your Digipeater SSID is greater than 15. This is not allowed. Please change the offending Digipeater SSID to be a number that is lower than 16.", vbCritical
        Exit Sub
      End If
      DigiCallStr(Y) = Mid(DigiCallStr(Y), 1, InStr(DigiCallStr(Y), "-") - 1)
    Else
      DigiCallSsidByt(Y) = 96
    End If
    If Len(DigiCallStr(Y)) < 6 Then DigiCallStr(Y) = DigiCallStr(Y) + Space(6 - Len(DigiCallStr(Y)))
  Next Y
  DigiCallSsidByt(x) = DigiCallSsidByt(x) + 1
  Y = 0
  For zz = 1 To x
    For z = 1 To 6
      If Y = 48 Then
        MsgBox "One or more of Your Digipeater Call Sign has more than 6 Characters. This is not allowed. Please change your Digipeater Call Sign to have no more than 6 Characters Max.", vbCritical
        Exit Sub
      End If
      Y = Y + 1
      DigiCallByt(Y) = Asc(Mid(DigiCallStr(zz), z, 1)) * 2
    Next z
  Next zz
Else
  FromCallSsidByt = FromCallSsidByt + 1
End If

sPacketOut = sPacketOut + Chr$(FromCallSsidByt)

Y = 0
If x <> 0 Then
  For zz = 1 To x
    For z = 1 To 6
      Y = Y + 1
      Shold = Chr$(DigiCallByt(Y))
      If Shold = Chr$(192) Then
        Shold = Chr$(219) + Chr$(220)
      Else
        If Shold = Chr$(219) Then Shold = Chr$(219) + Chr$(221)
      End If
      sPacketOut = sPacketOut + Shold
    Next z
    If Hbit(zz) = "*" Then DigiCallSsidByt(zz) = DigiCallSsidByt(zz) + 128
    sPacketOut = sPacketOut + Chr$(DigiCallSsidByt(zz))
  Next zz
End If

Stemp = OutUserData
OutUserData = ""
For x = 1 To Len(Stemp)
  Shold = Mid(Stemp, x, 1)
  Select Case Shold
         Case Chr$(192)
           Shold = Chr$(219) + Chr$(220)
         Case Chr$(219)
           Shold = Chr$(219) + Chr$(221)
  End Select
  OutUserData = OutUserData + Shold
Next x

sPacketOut = sPacketOut + Chr$(3) + Chr$(240) + OutUserData + Chr$(192)
If WhPortSend = "" Then
  If ConMdiFrm!PortTnc.Checked = True Then ConMdiFrm!MSComm1.Output = sPacketOut
  If ConMdiFrm!SoundSoc.Connected = True Then ConMdiFrm!SoundSoc.Write sPacketOut, Len(sPacketOut)
Else
  If WhPortSend = "TNC" Then 'This is an ack
    ConMdiFrm!MSComm1.Output = sPacketOut
  Else
    ConMdiFrm!SoundSoc.Write sPacketOut, Len(sPacketOut)
  End If
End If
'debug.Print sPacketOut
End Sub

Public Sub KissDigiPeat(DigiCalls As String, z As Integer, KissSearch As String)
Dim MyCMyAPos As Integer
Dim x As Integer
Dim Shold As String

Shold = Mid(DigiCalls, 2, Len(DigiCalls) - 1)

MyCMyAPos = InStr(Shold, KissSearch)
If MyCMyAPos <> 0 Then
  DigiCalls = Shold
  If MyCMyAPos = 1 Then
    If Mid(DigiCalls, Len(KissSearch) + 1, 1) <> "*" Then
      If Len(DigiCalls) = Len(KissSearch) Then
        DigiCalls = MyCall + "*"
      Else
        DigiCalls = MyCall + "*" + Mid(DigiCalls, Len(KissSearch) + 1)
      End If
      z = z + 1
    End If
  Else
    If Mid(DigiCalls, MyCMyAPos + Len(KissSearch), 1) <> "*" And Mid(DigiCalls, MyCMyAPos - 2, 1) = "*" Then
      'The above if statement checks to see if your digipeat call has already has its h-bit set
      'it also checks to see if the digipeat call before your digipeat call has had its h-bit set
      'if your digipeat calls h-bit is set then no digipeat of this packet. If the h-bit
      'of the digipeat call before your digipeat call has not been set then no digipeat of this packet
      'by this station.
      If Len(DigiCalls) = Len(KissSearch) + (MyCMyAPos - 1) Then
        DigiCalls = Left(DigiCalls, Len(DigiCalls) - Len(KissSearch)) + MyCall + "*"
      Else
        DigiCalls = Mid(DigiCalls, 1, MyCMyAPos - 1) + MyCall + "*" + Mid(DigiCalls, MyCMyAPos + Len(KissSearch))
      End If
      z = z + 1
    End If
  End If
  DigiCalls = "," + DigiCalls
End If
End Sub
