VERSION 5.00
Begin VB.Form PosAlarmFrm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Position Alarm"
   ClientHeight    =   3195
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   6030
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   6030
   ShowInTaskbar   =   0   'False
   Begin VB.Frame Frame1 
      Caption         =   "Select an Option"
      Height          =   2415
      Left            =   120
      TabIndex        =   2
      Top             =   240
      Width           =   2295
      Begin VB.ListBox AlarmLst 
         Height          =   840
         Left            =   240
         MultiSelect     =   2  'Extended
         TabIndex        =   5
         Top             =   1200
         Width           =   1575
      End
      Begin VB.OptionButton AlarmOPt 
         Caption         =   "Alarm Off"
         Height          =   495
         Index           =   1
         Left            =   1200
         Style           =   1  'Graphical
         TabIndex        =   4
         Top             =   360
         Visible         =   0   'False
         Width           =   855
      End
      Begin VB.OptionButton AlarmOPt 
         Caption         =   "Alarm On"
         Height          =   495
         Index           =   0
         Left            =   120
         Style           =   1  'Graphical
         TabIndex        =   3
         Top             =   360
         Value           =   -1  'True
         Visible         =   0   'False
         Width           =   855
      End
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4680
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Height          =   375
      Left            =   4680
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label1 
      Height          =   1815
      Left            =   2880
      TabIndex        =   6
      Top             =   1080
      Width           =   2895
   End
End
Attribute VB_Name = "PosAlarmFrm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub CancelButton_Click()
Unload PosAlarmFrm
End Sub

Private Sub Form_Load()
Dim x As Integer
Select Case PosMenuOpt
       Case "alarm"
         PosAlarmFrm.Caption = "Position Alarm"
         Label1.Caption = "Select alarm on or alarm off.             Alarm On will cause selected stations to be alarmed.                                      Alarm Off will cause selected stations to no longer be alarmed.                            In either case you can select multiple stations by holding the shift key and clicking on a station or by holding the ctrl key and clicking on a station."
         AlarmOPt(0).Visible = True
         AlarmOPt(1).Visible = True
       Case "delete"
         PosAlarmFrm.Caption = "Position Delete"
         Label1.Caption = "The Delition of an item only removes       the item from your map display. It does not remove the item from any ones display. If you are currently transmitting an object and wish to remove it from your map display and everyones  then use the Kill object menu Item.                                Note deleting an item does not remove the item from your position list."
End Select
For x = 0 To PositionFrm!PosLst.ListCount - 1
AlarmLst.AddItem RTrim(Left(PositionFrm!PosLst.List(x), 9))
Next x
End Sub

Private Sub OKButton_Click()
Dim x As Integer
Dim Shold As String
Dim CallSignSlected As Boolean

CallSignSlected = False

For x = 0 To AlarmLst.ListCount - 1
  If AlarmLst.Selected(x) And RTrim(Mid(PositionFrm!PosLst.List(x), 1, 9)) = MyCall Then
    MsgBox "You cannot select this stations callsign", vbCritical
    Exit Sub
  End If
  If AlarmLst.Selected(x) And Mid(PositionFrm!PosLst.List(x), 10, 1) <> "X" And Mid(PositionFrm!PosLst.List(x), 10, 1) <> "D" Then
    CallSignSlected = True
    Shold = PositionFrm!PosLst.List(x)
    Select Case PosMenuOpt
           Case "alarm"
             If AlarmOPt(0) Then
               Mid(Shold, 10, 1) = "A"
             Else
               Mid(Shold, 10, 1) = " "
             End If
             PositionFrm!PosLst.RemoveItem x
             PositionFrm!PosLst.AddItem Shold, x
           Case "delete"
             Mid(Shold, 10, 1) = "D"
             PositionFrm!PosLst.RemoveItem x
             PositionFrm!PosLst.AddItem Shold, x
             SymLoc(x).DisPlaySym = False
             MapFrm!SymPic(x).Visible = False
             MapFrm!SymLbl(x).Visible = False
    End Select
  End If
Next x

If Not CallSignSlected Then
  MsgBox "You have to select at least one call sign. Or the station you have selected is inactive. Either it has not been heard from for 2 hours or more or you have deleted it.", vbInformation
Else
  AlarmOPt(0).Visible = False
  AlarmOPt(1).Visible = False
  Unload PosAlarmFrm
End If
End Sub

