VERSION 5.00
Begin VB.Form frmSetup1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00400000&
   BorderStyle     =   0  'None
   ClientHeight    =   1770
   ClientLeft      =   225
   ClientTop       =   1590
   ClientWidth     =   7950
   ClipControls    =   0   'False
   DrawStyle       =   5  'Transparent
   FillStyle       =   0  'Solid
   BeginProperty Font 
      Name            =   "Times New Roman"
      Size            =   24
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   -1  'True
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   HasDC           =   0   'False
   Icon            =   "setup1.frx":0000
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   118
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   530
   WindowState     =   2  'Maximized
   Begin VB.Label lblModify 
      AutoSize        =   -1  'True
      BorderStyle     =   1  'Fixed Single
      Caption         =   $"setup1.frx":0442
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   15
      TabIndex        =   1
      Top             =   15
      Visible         =   0   'False
      Width           =   7860
      WordWrap        =   -1  'True
   End
   Begin VB.Label lblDDE 
      AutoSize        =   -1  'True
      BorderStyle     =   1  'Fixed Single
      Caption         =   "This label is used for DDE connection to the Program Manager"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   15
      TabIndex        =   0
      Top             =   1515
      Visible         =   0   'False
      Width           =   4485
   End
End
Attribute VB_Name = "frmSetup1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'
' Can't put this is a resource because it indicated resource load failure, must localize separately
'
Private Const mstrRESOURCELOADFAIL$ = "An error occurred while initializing string resources used by Setup."

'-----------------------------------------------------------
' SUB: DrawBackGround
'
' Draws the 'blue wash' screen and prints the 'shadowed'
' app setup title
'-----------------------------------------------------------
'
Private Sub DrawBackGround()
    Const intBLUESTART% = 255
    Const intBLUEEND% = 0
    Const intBANDHEIGHT% = 2
    Const intSHADOWSTART% = 8
    Const intSHADOWCOLOR% = 0
    Const intTEXTSTART% = 4
    Const intTEXTCOLOR% = 15
    Const intRed% = 1
    Const intGreen% = 2
    Const intBlue% = 4
    Const intBackRed% = 8
    Const intBackGreen% = 16
    Const intBackBlue% = 32
    Dim sngBlueCur As Single
    Dim sngBlueStep As Single
    Dim intFormHeight As Integer
    Dim intFormWidth As Integer
    Dim intY As Integer
    Dim iColor As Integer
    Dim iRed As Single, iBlue As Single, iGreen As Single
    
    '
    'Get system values for height and width
    '
    intFormHeight = ScaleHeight
    intFormWidth = ScaleWidth

    If Len(ReadIniFile(gstrSetupInfoFile, gstrINI_SETUP, gstrINI_COLOR)) = 0 Then
        iColor = intBlue
    Else
        iColor = CInt(ReadIniFile(gstrSetupInfoFile, gstrINI_SETUP, gstrINI_COLOR))
    End If
    'Calculate step size and blue start value
    '
    sngBlueStep = intBANDHEIGHT * (intBLUEEND - intBLUESTART) / intFormHeight
    sngBlueCur = intBLUESTART

    '
    'Paint blue screen
    '
    For intY = 0 To intFormHeight Step intBANDHEIGHT
        If iColor And intBlue Then iBlue = sngBlueCur
        If iColor And intRed Then iRed = sngBlueCur
        If iColor And intGreen Then iGreen = sngBlueCur
        If iColor And intBackBlue Then iBlue = 255 - sngBlueCur
        If iColor And intBackRed Then iRed = 255 - sngBlueCur
        If iColor And intBackGreen Then iGreen = 255 - sngBlueCur
        Line (-1, intY - 1)-(intFormWidth, intY + intBANDHEIGHT), RGB(iRed, iGreen, iBlue), BF
        sngBlueCur = sngBlueCur + sngBlueStep
    Next intY

    '
    'Print 'shadowed' appname
    '
    CurrentX = intSHADOWSTART
    CurrentY = intSHADOWSTART
    ForeColor = QBColor(intSHADOWCOLOR)
    Print Caption
    CurrentX = intTEXTSTART
    CurrentY = intTEXTSTART
    ForeColor = QBColor(intTEXTCOLOR)
    Print Caption
End Sub
Private Sub Form_Load()
'
' Most of the work for Setup1 takes place in Form_Load()
' and is mostly driven by the information found in the
' SETUP.LST file.  To customize the Setup1 functionality,
' you will generally want to modify SETUP.LST.
' Particularly, information regarding the files you are
' installing is all stored in SETUP.LST.  Exceptions include
' the Remote Automation files RacMgr32.Exe and AutMgr32.Exe
' and special redistributable packages such as mdac_typ.exe.
' These require special handling below.
'
' Some customization can also be done by editing the code
' below in Form_Load or in other parts of this program.
' Places that are more likely to need customization are
' documented with suggestions and examples in the code.
'

    '
    'Uncomment these three lines for debugging.  To debug:
    '1) Rebuild Setup1.exe and rebuild the cab file
    '   to include the new Setup1.exe.
    '2) Run setup.exe against the new cab
    '3) When the message box appears, open the Setup1 project
    '   in VB, paste the command line from the clipboard into the
    '   Project/Properties/Make/Command Line Arguments field.
    '4) F5 in VB.
    '
    'Clipboard.Clear
    'Clipboard.SetText Command$
    'MsgBox Command$
    
    Const fDefCreateGroupUnderWin95 = False

    Dim strGroupName As String                              'Name of Program Group
    Dim oFont As StdFont
    Dim lChar As Long
    Dim cIcons As Integer            ' Count of how many icons are required.
    Dim cGroups As Integer           ' Count of how many groups are required.
    Dim fCreateGroup As Boolean

    Dim iLoop As Integer
    Dim sUCASEStartMenuKey As String
    Dim sUCASEProgramsMenuKey As String
    Dim sGroup As String

    Dim strRemAutGroupName As String

    Dim strPerAppPath As String

    Dim iRet As Integer

    gfRegDAO = False
    
    On Error GoTo MainError

    SetFormFont Me
    'All the controls and the form are sharing the
    'same font object, so create a new font object
    'for the form so that the appearance of all the
    'controls are not changed also
    Set oFont = New StdFont
    With oFont
        .Size = 24
        .Bold = True
        .Italic = True
        .Charset = lblModify.Font.Charset
        .Name = lblModify.Font.Name
    End With
    Set Font = oFont
    '
    'Initialize string resources used by global vars and forms/controls
    '
    GetStrings
    
    '
    'Get Windows, Windows\Fonts, and Windows\System directories
    '
    gstrWinDir = GetWindowsDir()
    gstrWinSysDir = GetWindowsSysDir()
    gstrFontDir = GetWindowsFontDir()

    '
    ' If the Windows System directory is a subdirectory of the
    ' Windows directory, the proper place for installation of
    ' files specified in the setup.lst as $(WinSysDest) is always
    ' the Windows \System directory.  If the Windows \System
    ' directory is *not* a subdirectory of the Windows directory,
    ' then the user is running a shared version of Windows.  In
    ' this case, if the user does not have write access to the
    ' shared system directory, we change the system files
    ' destination to the windows directory
    '
    ' Avoid Option Compare Text and use explicit UCase comparisons because there
    ' is a Unicode character (&H818F) which is equal to a path separator when
    ' using Option Compare Text.
    If InStr(UCase$(gstrWinSysDir), UCase$(gstrWinDir)) <> 1 Then
        If Not WriteAccess(gstrWinSysDir) Then
            gstrWinSysDir = gstrWinDir
        End If
    End If

    '
    ' The command-line arguments must be processed as early
    ' as possible, because without them it is impossible to
    ' call the app removal program to clean up after an aborted
    ' setup.
    '
#If SMS Then
    ProcessCommandLine Command$, gfSilent, gstrSilentLog, gfSMS, gstrMIFFile, gstrSrcPath, gstrAppRemovalLog, gstrAppRemovalEXE
    gfNoUserInput = (gfSilent Or gfSMS)
#Else
    ProcessCommandLine Command$, gfSilent, gstrSilentLog, gstrSrcPath, gstrAppRemovalLog, gstrAppRemovalEXE
    gfNoUserInput = gfSilent
#End If

    AddDirSep gstrSrcPath
'Here is where I have added code to save the install
'source directory. The directory where the user has
'unziped pmmapfull.exe

Dim JbSourceDir As String

JbSourceDir = gstrSrcPath
    

    '
    ' The Setup Bootstrapper (SETUP.EXE) copies SETUP1.EXE and SETUP.LST to
    ' the end user's windows directory.  Information required for setup such
    ' as setup flags and fileinfo is read from the copy of SETUP.LST found in
    ' that directory.
    '
    gstrSetupInfoFile = gstrWinDir & gstrFILE_SETUP
    'Get the Appname (this will be shown on the blue wash screen)
    gstrAppName = ReadIniFile(gstrSetupInfoFile, gstrINI_SETUP, gstrINI_APPNAME)
    gintCabs = CInt(ReadIniFile(gstrSetupInfoFile, gstrINI_BOOT, gstrINI_CABS))
    If Len(gstrAppName) = 0 Then
        MsgError ResolveResString(resNOSETUPLST), vbOKOnly Or vbCritical, gstrSETMSG
        gstrTitle = ResolveResString(resSETUP, gstrPIPE1, gstrAppName)
        ExitSetup Me, gintRET_FATAL
    End If

    gstrAppExe = ReadIniFile(gstrSetupInfoFile, gstrINI_SETUP, gstrINI_APPEXE)
    gstrTitle = ResolveResString(resSETUP, gstrPIPE1, gstrAppName)
    If gfSilent Then LogSilentMsg gstrTitle & vbCrLf

    'Get a temporary directory to use
    gsTEMPDIR = String$(255, 0)
    lChar = GetTempPath(255, gsTEMPDIR)
    gsTEMPDIR = Left$(gsTEMPDIR, lChar)
    AddDirSep gsTEMPDIR
    gsTEMPDIR = gsTEMPDIR & ReadIniFile(gstrSetupInfoFile, gstrINI_BOOT, gsINI_TEMPDIR)
    AddDirSep gsTEMPDIR
    '
    ' Get the name of the CAB
    '
    gsCABFULLNAME = gstrWinDir & ReadIniFile(gstrSetupInfoFile, gstrINI_BOOT, gstrINI_CABNAME)
    '
    ' Display the background "blue-wash" setup screen as soon as we get the title
    '
    ShowMainForm
    '
    ' Display the welcome dialog
    '
    ShowWelcomeForm
    '
    ' If this flag is set, then the default destination directory is used
    ' without question, and the user is never given a chance to change it.
    ' This is intended for installing an .EXE/.DLL as a component rather
    ' than as an application in an application directory.  In this case,
    ' having an application directory does not really make sense.
    '
    If ReadIniFile(gstrSetupInfoFile, gstrINI_SETUP, gstrINI_FORCEUSEDEFDEST) = "1" Then
        gfForceUseDefDest = True
    End If
    '
    ' Read default destination directory.  If the name specified conflicts
    ' with the name of a file, then prompt for a new default directory
    '
    gstrDestDir = ResolveDestDir(ReadIniFile(gstrSetupInfoFile, gstrINI_SETUP, gstrINI_APPDIR))
    Do While FileExists(gstrDestDir) Or Len(gstrDestDir) = 0
        If MsgError(ResolveResString(resBADDEFDIR), vbOKCancel Or vbQuestion, gstrSETMSG) = vbCancel Then
            ExitSetup Me, gintRET_FATAL
        End If

        If gfNoUserInput Then
            ExitSetup Me, gintRET_FATAL
        Else
            ShowPathDialog
        End If
    Loop
    '
    ' Ensure a trailing backslash on the destination directory
    '
    AddDirSep gstrDestDir

    Do
        '
        ' Display install button and default directory.  The user
        ' can change the destination directory from here.
        '
        ShowBeginForm
        '
        ' This would be a good place to display an option dialog, allowing the user
        ' a chance to select installation options: samples, docs, help files, etc.
        ' Results of this dialog would be checked in the loop below
        '
        'ShowOptionsDialog (Function you could write with option check boxes, etc.)
        '

        '
        ' Initialize "table" of drives used and disk space array
        '
        InitDiskInfo

        SetMousePtr vbHourglass
        ShowStaticMessageDialog ResolveResString(resDISKSPACE)
        '
        ' For every section in SETUP.LST that will be installed, call CalcDiskSpace
        ' with the name of the section
        '
        CalcDiskSpace gstrINI_FILES
        'CalcDiskSpace "MySection"
        'CalcDiskSpace "MyOtherSection"
        '
        ' If you created an options dialog, you need to check results here to
        ' determine whether disk space needs to be calculated (if the option(s)
        ' will be installed)
        '
        'If chkInstallSamples.Value then
        '    CalcDiskSpace "Samples"
        'End If
        '

        HideStaticMessageDialog
        SetMousePtr vbDefault

    '
    ' After all CalcDiskSpace calls are complete, call CheckDiskSpace to check
    ' the results and display warning form (if necessary).  If the user wants
    ' to try another destination directory (or cleanup and retry) then
    ' CheckDiskSpace will return False
    '
    Loop Until CheckDiskSpace()
    '
    ' Starts logging to the setup logfile (will be used for application removal)
    '
    EnableLogging gstrAppRemovalLog
    '
    ' Should go ahead and force the application directory to be created,
    ' since the application removal logfile will later be copied there.
    '
    MakePath gstrDestDir, False 'User may not ignore errors here
    '
    ' Create the main program group if one is wanted/needed.
    '
    '
    ' If fDefCreateGroupUnderWin95 is set to False (this is the default), then no
    ' program group will be created under Win95 unless it is absolutely necessary.
    '
    ' By default under Windows 95, no group should be created, and the
    ' single program icon should be placed directly under the
    ' Start>Programs menu (unless there are other, user-defined icons to create
    '
    '
    ' Read through the SETUP.LST file and determine how many icons are needed.
    '
    cIcons = CountIcons(gsICONGROUP)
    cGroups = CountGroups(gsICONGROUP)
    '
    ' Do the same for other sections in SETUP.LST if you've added your own.
    '
    'cIcons = cIcons + CountIcons("MySection")
    'cIcons = cIcons + CountIcons("MyOtherSection")
    
    '
    ' The following variable determines whether or not we create a program
    ' group for icons.  It is controlled by fNoGroupUnderWin95,
    ' fAdditionalIcons, and FTreatAsWin95().
    '
    fCreateGroup = (cGroups > 0)
    
    If fCreateGroup Then
        For iLoop = 0 To cGroups - 1
            sGroup = GetGroup(gsICONGROUP, iLoop)
            strGroupName = vbNullString
            Select Case UCase$(sGroup)
                Case UCase$(gsSTARTMENUKEY), UCase$(gsPROGMENUKEY)
                    ' Skip start menu and programs - they're already there and don't
                    ' need to be created.
                Case Else
                    strGroupName = frmGroup.GroupName(frmSetup1, sGroup, GetPrivate(gsICONGROUP, iLoop), GetStart(gsICONGROUP, iLoop))
                    If UCase$(sGroup) <> UCase$(strGroupName) Then
                        SetGroup gsICONGROUP, iLoop, strGroupName
                    End If
            End Select
            fMainGroupWasCreated = True
        Next
    End If
    
    ' Before we begin copying files, check for mdac_typ
    ' and if we find it, spawn that off first.  We will tell
    ' it to never reboot, and check at the end to see if we need to.
    DoEvents
    If CheckDataAccess Then
        'We need to install data access.  Display message.
        ShowStaticMessageDialog ResolveResString(resINSTALLADO)
        InstallDataAccess
        HideStaticMessageDialog
    End If
    '
    ' Show copy form and set copy gauge percentage to zero
    '
    SetMousePtr vbHourglass
    ShowCopyDialog
    UpdateStatus frmCopy.picStatus, 0, True
    '
    ' Always start with Disk #1
    '
    gintCurrentDisk = 1
    '
    ' For every section in SETUP.LST that needs to be installed, call CopySection
    ' with the name of the section
    '
    
    CopySection gstrINI_FILES
    'CopySection "MySection"
    'CopySection "MyOtherSection"
        
    '
    ' If you created an options dialog, you need to check results here to
    ' determine whether to copy the files in the particular section(s).
    '
    'If chkInstallSamples.Value then
    '    CopySection "Samples"
    'End If
    '
    UpdateStatus frmCopy.picStatus, 1, True

    HideCopyDialog
    '
    ' Now, do all the 'invisible' update things that are required
    '
    SetMousePtr vbDefault
    ShowStaticMessageDialog ResolveResString(resUPDATING)
    '
    ' Register all the files that have been saved in the registration array.  The
    ' CopySection API adds a registration entry (when required) if a file is copied.
    '
    RegisterFiles
    '
    ' Register all the licenses that appear in the [Licenses] section of
    ' Setup.lst.
    '
    RegisterLicenses
    '
    ' If any DAO files were installed, we need to add some special
    ' keys to the registry to support it so that links will work
    ' in OLE Database fields.
    '
    If gfRegDAO Then
        RegisterDAO
    End If
    '
    ' Create program icons (or links, i.e. shortcuts).
    '
    If fMainGroupWasCreated Or (cIcons > 0) Then
        ShowStaticMessageDialog ResolveResString(resPROGMAN)
        CreateIcons gsICONGROUP
        '
        ' Do the same for other sections in SETUP.LST if you've added your own.
        '
        'CreateIcons "MySection"
        'CreateIcons "MyOtherSection"
        '
    End If
    '
    ' Create a separate program group and icons for the Remote Automation
    ' Connection Manager and the Automation Manager, if either has been
    ' installed.
    ' This program group is entirely separate from the one created for the
    ' application program (if any), because it will be shared by all
    ' VB applications which install them.
    '
    ' NOTE: This is NOT the place to install additional icons.  This is
    ' NOTE: handled after the Remote Automation icons have been created.
    '
    ShowStaticMessageDialog ResolveResString(resPROGMAN)
    If Len(gsDest.strAUTMGR32) > 0 Or Len(gsDest.strRACMGR32) > 0 Then
        'At least one of these programs was installed.  Go ahead
        'and create the program group.
        strRemAutGroupName = ResolveResString(resREMAUTGROUPNAME)
        '
        ' Create the group for the Remote Automation Icons.  Note that
        ' since the user cannot choose the name of this group, there is
        ' no way at this point to correct an error if one occurs.  Therefore,
        ' fCreateShellGroup will abort setup, without returning, if there
        ' is an error.
        '
        fCreateShellGroup strRemAutGroupName, False, False

        'Now create the icons for AUTMGR32.EXE and RACMGR32.EXE
        If Len(gsDest.strRACMGR32) > 0 Then
            CreateShellLink gsDest.strRACMGR32, strRemAutGroupName, vbNullString, ResolveResString(resRACMGR32ICON), True, gsPROGMENUKEY, False
        End If
        If Len(gsDest.strAUTMGR32) > 0 Then
            CreateShellLink gsDest.strAUTMGR32, strRemAutGroupName, vbNullString, ResolveResString(resAUTMGR32ICON), True, gsPROGMENUKEY, False
        End If
    End If
    '
    'Register the per-app path
    '
    If Len(gstrAppExe) > 0 Then
        strPerAppPath = ReadIniFile(gstrSetupInfoFile, gstrINI_SETUP, gstrINI_APPPATH)
        AddPerAppPath gstrAppExe, gsDest.strAppDir, strPerAppPath
    End If
'Here is where I have added my code to create
'the sub directories I need and copy copy the files to
'those sub directories

MkDir gstrDestDir & "History"
MkDir gstrDestDir & "Log"
MkDir gstrDestDir & "MapBmpGif"
MkDir gstrDestDir & "BitMap"
MkDir gstrDestDir & "Symbols"
MkDir gstrDestDir & "Symbols\Table1"
MkDir gstrDestDir & "Symbols\Table2"

Dim Johnb As Integer
Dim KB2SCS(747) As String

KB2SCS(1) = "033A.GIF"
KB2SCS(2) = "034A.GIF"
KB2SCS(3) = "035A.GIF"
KB2SCS(4) = "036A.GIF"
KB2SCS(5) = "037A.GIF"
KB2SCS(6) = "038A.GIF"
KB2SCS(7) = "039A.GIF"
KB2SCS(8) = "040A.GIF"
KB2SCS(9) = "041A.GIF"
KB2SCS(10) = "042A.GIF"
KB2SCS(11) = "043A.GIF"
KB2SCS(12) = "044A.GIF"
KB2SCS(13) = "045A.GIF"
KB2SCS(14) = "046A.GIF"
KB2SCS(15) = "047A.GIF"
KB2SCS(16) = "048A.GIF"
KB2SCS(17) = "049A.GIF"
KB2SCS(18) = "050A.GIF"
KB2SCS(19) = "051A.GIF"
KB2SCS(20) = "052A.GIF"
KB2SCS(21) = "053A.GIF"
KB2SCS(22) = "054A.GIF"
KB2SCS(23) = "055A.GIF"
KB2SCS(24) = "056A.GIF"
KB2SCS(25) = "057A.GIF"
KB2SCS(26) = "058A.GIF"
KB2SCS(27) = "059A.GIF"
KB2SCS(28) = "060A.GIF"
KB2SCS(29) = "061A.GIF"
KB2SCS(30) = "062A.GIF"
KB2SCS(31) = "063A.GIF"
KB2SCS(32) = "064A.GIF"
KB2SCS(33) = "065A.GIF"
KB2SCS(34) = "066A.GIF"
KB2SCS(35) = "067A.GIF"
KB2SCS(36) = "068A.GIF"
KB2SCS(37) = "069A.GIF"
KB2SCS(38) = "070A.GIF"
KB2SCS(39) = "071A.GIF"
KB2SCS(40) = "072A.GIF"
KB2SCS(41) = "073A.GIF"
KB2SCS(42) = "074A.GIF"
KB2SCS(43) = "075A.GIF"
KB2SCS(44) = "076A.GIF"
KB2SCS(45) = "077A.GIF"
KB2SCS(46) = "078A.GIF"
KB2SCS(47) = "079A.GIF"
KB2SCS(48) = "080A.GIF"
KB2SCS(49) = "081A.GIF"
KB2SCS(50) = "082A.GIF"
KB2SCS(51) = "083A.GIF"
KB2SCS(52) = "084A.GIF"
KB2SCS(53) = "085A.GIF"
KB2SCS(54) = "086A.GIF"
KB2SCS(55) = "087A.GIF"
KB2SCS(56) = "088A.GIF"
KB2SCS(57) = "089A.GIF"
KB2SCS(58) = "090A.GIF"
KB2SCS(59) = "091A.GIF"
KB2SCS(60) = "092A.GIF"
KB2SCS(61) = "093A.GIF"
KB2SCS(62) = "094A.GIF"
KB2SCS(63) = "095A.GIF"
KB2SCS(64) = "096A.GIF"
KB2SCS(65) = "097A.GIF"
KB2SCS(66) = "098A.GIF"
KB2SCS(67) = "099A.GIF"
KB2SCS(68) = "100A.GIF"
KB2SCS(69) = "101A.GIF"
KB2SCS(70) = "102A.GIF"
KB2SCS(71) = "103A.GIF"
KB2SCS(72) = "104A.GIF"
KB2SCS(73) = "105A.GIF"
KB2SCS(74) = "106A.GIF"
KB2SCS(75) = "107A.GIF"
KB2SCS(76) = "108A.GIF"
KB2SCS(77) = "109A.GIF"
KB2SCS(78) = "110A.GIF"
KB2SCS(79) = "111A.GIF"
KB2SCS(80) = "112A.GIF"
KB2SCS(81) = "113A.GIF"
KB2SCS(82) = "114A.GIF"
KB2SCS(83) = "115A.GIF"
KB2SCS(84) = "116A.GIF"
KB2SCS(85) = "117A.GIF"
KB2SCS(86) = "118A.GIF"
KB2SCS(87) = "119A.GIF"
KB2SCS(88) = "120A.GIF"
KB2SCS(89) = "121A.GIF"
KB2SCS(90) = "122A.GIF"
KB2SCS(91) = "123A.GIF"
KB2SCS(92) = "124A.GIF"
KB2SCS(93) = "125A.GIF"
KB2SCS(94) = "126A.GIF"
KB2SCS(95) = "033.GIF"
KB2SCS(96) = "034.GIF"
KB2SCS(97) = "035_48.GIF"
KB2SCS(98) = "035_49.GIF"
KB2SCS(99) = "035_50.GIF"
KB2SCS(100) = "035_51.GIF"
KB2SCS(101) = "035_52.GIF"
KB2SCS(102) = "035_53.GIF"
KB2SCS(103) = "035_54.GIF"
KB2SCS(104) = "035_55.GIF"
KB2SCS(105) = "035_56.GIF"
KB2SCS(106) = "035_57.GIF"
KB2SCS(107) = "035_65.GIF"
KB2SCS(108) = "035_66.GIF"
KB2SCS(109) = "035_67.GIF"
KB2SCS(110) = "035_68.GIF"
KB2SCS(111) = "035_69.GIF"
KB2SCS(112) = "035_70.GIF"
KB2SCS(113) = "035_71.GIF"
KB2SCS(114) = "035_72.GIF"
KB2SCS(115) = "035_73.GIF"
KB2SCS(116) = "035_74.GIF"
KB2SCS(117) = "035_75.GIF"
KB2SCS(118) = "035_76.GIF"
KB2SCS(119) = "035_77.GIF"
KB2SCS(120) = "035_78.GIF"
KB2SCS(121) = "035_79.GIF"
KB2SCS(122) = "035_80.GIF"
KB2SCS(123) = "035_81.GIF"
KB2SCS(124) = "035_82.GIF"
KB2SCS(125) = "035_83.GIF"
KB2SCS(126) = "035_84.GIF"
KB2SCS(127) = "035_85.GIF"
KB2SCS(128) = "035_86.GIF"
KB2SCS(129) = "035_87.GIF"
KB2SCS(130) = "035_88.GIF"
KB2SCS(131) = "035_89.GIF"
KB2SCS(132) = "035_90.GIF"
KB2SCS(133) = "036.GIF"
KB2SCS(134) = "037.GIF"
KB2SCS(135) = "038_48.GIF"
KB2SCS(136) = "038_49.GIF"
KB2SCS(137) = "038_50.GIF"
KB2SCS(138) = "038_51.GIF"
KB2SCS(139) = "038_52.GIF"
KB2SCS(140) = "038_53.GIF"
KB2SCS(141) = "038_54.GIF"
KB2SCS(142) = "038_55.GIF"
KB2SCS(143) = "038_56.GIF"
KB2SCS(144) = "038_57.GIF"
KB2SCS(145) = "038_65.GIF"
KB2SCS(146) = "038_66.GIF"
KB2SCS(147) = "038_67.GIF"
KB2SCS(148) = "038_68.GIF"
KB2SCS(149) = "038_69.GIF"
KB2SCS(150) = "038_70.GIF"
KB2SCS(151) = "038_71.GIF"
KB2SCS(152) = "038_72.GIF"
KB2SCS(153) = "038_73.GIF"
KB2SCS(154) = "038_74.GIF"
KB2SCS(155) = "038_75.GIF"
KB2SCS(156) = "038_76.GIF"
KB2SCS(157) = "038_77.GIF"
KB2SCS(158) = "038_78.GIF"
KB2SCS(159) = "038_79.GIF"
KB2SCS(160) = "038_80.GIF"
KB2SCS(161) = "038_81.GIF"
KB2SCS(162) = "038_82.GIF"
KB2SCS(163) = "038_83.GIF"
KB2SCS(164) = "038_84.GIF"
KB2SCS(165) = "038_85.GIF"
KB2SCS(166) = "038_86.GIF"
KB2SCS(167) = "038_87.GIF"
KB2SCS(168) = "038_88.GIF"
KB2SCS(169) = "038_89.GIF"
KB2SCS(170) = "038_90.GIF"
KB2SCS(171) = "039.GIF"
KB2SCS(172) = "040.GIF"
KB2SCS(173) = "041.GIF"
KB2SCS(174) = "042.GIF"
KB2SCS(175) = "043.GIF"
KB2SCS(176) = "044.GIF"
KB2SCS(177) = "045.GIF"
KB2SCS(178) = "046.GIF"
KB2SCS(179) = "047.GIF"
KB2SCS(180) = "048_48.GIF"
KB2SCS(181) = "048_49.GIF"
KB2SCS(182) = "048_50.GIF"
KB2SCS(183) = "048_51.GIF"
KB2SCS(184) = "048_52.GIF"
KB2SCS(185) = "048_53.GIF"
KB2SCS(186) = "048_54.GIF"
KB2SCS(187) = "048_55.GIF"
KB2SCS(188) = "048_56.GIF"
KB2SCS(189) = "048_57.GIF"
KB2SCS(190) = "048_65.GIF"
KB2SCS(191) = "048_66.GIF"
KB2SCS(192) = "048_67.GIF"
KB2SCS(193) = "048_68.GIF"
KB2SCS(194) = "048_69.GIF"
KB2SCS(195) = "048_70.GIF"
KB2SCS(196) = "048_71.GIF"
KB2SCS(197) = "048_72.GIF"
KB2SCS(198) = "048_73.GIF"
KB2SCS(199) = "048_74.GIF"
KB2SCS(200) = "048_75.GIF"
KB2SCS(201) = "048_76.GIF"
KB2SCS(202) = "048_77.GIF"
KB2SCS(203) = "048_78.GIF"
KB2SCS(204) = "048_79.GIF"
KB2SCS(205) = "048_80.GIF"
KB2SCS(206) = "048_81.GIF"
KB2SCS(207) = "048_82.GIF"
KB2SCS(208) = "048_83.GIF"
KB2SCS(209) = "048_84.GIF"
KB2SCS(210) = "048_85.GIF"
KB2SCS(211) = "048_86.GIF"
KB2SCS(212) = "048_87.GIF"
KB2SCS(213) = "048_88.GIF"
KB2SCS(214) = "048_89.GIF"
KB2SCS(215) = "048_90.GIF"
KB2SCS(216) = "049.GIF"
KB2SCS(217) = "050.GIF"
KB2SCS(218) = "051.GIF"
KB2SCS(219) = "052.GIF"
KB2SCS(220) = "053.GIF"
KB2SCS(221) = "054.GIF"
KB2SCS(222) = "055.GIF"
KB2SCS(223) = "056.GIF"
KB2SCS(224) = "057.GIF"
KB2SCS(225) = "058.GIF"
KB2SCS(226) = "059.GIF"
KB2SCS(227) = "060.GIF"
KB2SCS(228) = "061.GIF"
KB2SCS(229) = "062_48.GIF"
KB2SCS(230) = "062_49.GIF"
KB2SCS(231) = "062_50.GIF"
KB2SCS(232) = "062_51.GIF"
KB2SCS(233) = "062_52.GIF"
KB2SCS(234) = "062_53.GIF"
KB2SCS(235) = "062_54.GIF"
KB2SCS(236) = "062_55.GIF"
KB2SCS(237) = "062_56.GIF"
KB2SCS(238) = "062_57.GIF"
KB2SCS(239) = "062_65.GIF"
KB2SCS(240) = "062_66.GIF"
KB2SCS(241) = "062_67.GIF"
KB2SCS(242) = "062_68.GIF"
KB2SCS(243) = "062_69.GIF"
KB2SCS(244) = "062_70.GIF"
KB2SCS(245) = "062_71.GIF"
KB2SCS(246) = "062_72.GIF"
KB2SCS(247) = "062_73.GIF"
KB2SCS(248) = "062_74.GIF"
KB2SCS(249) = "062_75.GIF"
KB2SCS(250) = "062_76.GIF"
KB2SCS(251) = "062_77.GIF"
KB2SCS(252) = "062_78.GIF"
KB2SCS(253) = "062_79.GIF"
KB2SCS(254) = "062_80.GIF"
KB2SCS(255) = "062_81.GIF"
KB2SCS(256) = "062_82.GIF"
KB2SCS(257) = "062_83.GIF"
KB2SCS(258) = "062_84.GIF"
KB2SCS(259) = "062_85.GIF"
KB2SCS(260) = "062_86.GIF"
KB2SCS(261) = "062_87.GIF"
KB2SCS(262) = "062_88.GIF"
KB2SCS(263) = "062_89.GIF"
KB2SCS(264) = "062_90.GIF"
KB2SCS(265) = "063.GIF"
KB2SCS(266) = "064.GIF"
KB2SCS(267) = "065_48.GIF"
KB2SCS(268) = "065_49.GIF"
KB2SCS(269) = "065_50.GIF"
KB2SCS(270) = "065_51.GIF"
KB2SCS(271) = "065_52.GIF"
KB2SCS(272) = "065_53.GIF"
KB2SCS(273) = "065_54.GIF"
KB2SCS(274) = "065_55.GIF"
KB2SCS(275) = "065_56.GIF"
KB2SCS(276) = "065_57.GIF"
KB2SCS(277) = "065_65.GIF"
KB2SCS(278) = "065_66.GIF"
KB2SCS(279) = "065_67.GIF"
KB2SCS(280) = "065_68.GIF"
KB2SCS(281) = "065_69.GIF"
KB2SCS(282) = "065_70.GIF"
KB2SCS(283) = "065_71.GIF"
KB2SCS(284) = "065_72.GIF"
KB2SCS(285) = "065_73.GIF"
KB2SCS(286) = "065_74.GIF"
KB2SCS(287) = "065_75.GIF"
KB2SCS(288) = "065_76.GIF"
KB2SCS(289) = "065_77.GIF"
KB2SCS(290) = "065_78.GIF"
KB2SCS(291) = "065_79.GIF"
KB2SCS(292) = "065_80.GIF"
KB2SCS(293) = "065_81.GIF"
KB2SCS(294) = "065_82.GIF"
KB2SCS(295) = "065_83.GIF"
KB2SCS(296) = "065_84.GIF"
KB2SCS(297) = "065_85.GIF"
KB2SCS(298) = "065_86.GIF"
KB2SCS(299) = "065_87.GIF"
KB2SCS(300) = "065_88.GIF"
KB2SCS(301) = "065_89.GIF"
KB2SCS(302) = "065_90.GIF"
KB2SCS(303) = "066.GIF"
KB2SCS(304) = "067.GIF"
KB2SCS(305) = "068.GIF"
KB2SCS(306) = "069.GIF"
KB2SCS(307) = "070.GIF"
KB2SCS(308) = "071.GIF"
KB2SCS(309) = "072.GIF"
KB2SCS(310) = "073.GIF"
KB2SCS(311) = "074.GIF"
KB2SCS(312) = "075.GIF"
KB2SCS(313) = "076.GIF"
KB2SCS(314) = "077.GIF"
KB2SCS(315) = "078.GIF"
KB2SCS(316) = "079.GIF"
KB2SCS(317) = "080.GIF"
KB2SCS(318) = "081.GIF"
KB2SCS(319) = "082.GIF"
KB2SCS(320) = "083.GIF"
KB2SCS(321) = "084.GIF"
KB2SCS(322) = "085.GIF"
KB2SCS(323) = "086.GIF"
KB2SCS(324) = "087_48.GIF"
KB2SCS(325) = "087_49.GIF"
KB2SCS(326) = "087_50.GIF"
KB2SCS(327) = "087_51.GIF"
KB2SCS(328) = "087_52.GIF"
KB2SCS(329) = "087_53.GIF"
KB2SCS(330) = "087_54.GIF"
KB2SCS(331) = "087_55.GIF"
KB2SCS(332) = "087_56.GIF"
KB2SCS(333) = "087_57.GIF"
KB2SCS(334) = "087_65.GIF"
KB2SCS(335) = "087_66.GIF"
KB2SCS(336) = "087_67.GIF"
KB2SCS(337) = "087_68.GIF"
KB2SCS(338) = "087_69.GIF"
KB2SCS(339) = "087_70.GIF"
KB2SCS(340) = "087_71.GIF"
KB2SCS(341) = "087_72.GIF"
KB2SCS(342) = "087_73.GIF"
KB2SCS(343) = "087_74.GIF"
KB2SCS(344) = "087_75.GIF"
KB2SCS(345) = "087_76.GIF"
KB2SCS(346) = "087_77.GIF"
KB2SCS(347) = "087_78.GIF"
KB2SCS(348) = "087_79.GIF"
KB2SCS(349) = "087_80.GIF"
KB2SCS(350) = "087_81.GIF"
KB2SCS(351) = "087_82.GIF"
KB2SCS(352) = "087_83.GIF"
KB2SCS(353) = "087_84.GIF"
KB2SCS(354) = "087_85.GIF"
KB2SCS(355) = "087_86.GIF"
KB2SCS(356) = "087_87.GIF"
KB2SCS(357) = "087_88.GIF"
KB2SCS(358) = "087_89.GIF"
KB2SCS(359) = "087_90.GIF"
KB2SCS(360) = "088.GIF"
KB2SCS(361) = "089.GIF"
KB2SCS(362) = "090.GIF"
KB2SCS(363) = "091.GIF"
KB2SCS(364) = "092.GIF"
KB2SCS(365) = "093.GIF"
KB2SCS(366) = "094_48.GIF"
KB2SCS(367) = "094_49.GIF"
KB2SCS(368) = "094_50.GIF"
KB2SCS(369) = "094_51.GIF"
KB2SCS(370) = "094_52.GIF"
KB2SCS(371) = "094_53.GIF"
KB2SCS(372) = "094_54.GIF"
KB2SCS(373) = "094_55.GIF"
KB2SCS(374) = "094_56.GIF"
KB2SCS(375) = "094_57.GIF"
KB2SCS(376) = "094_65.GIF"
KB2SCS(377) = "094_66.GIF"
KB2SCS(378) = "094_67.GIF"
KB2SCS(379) = "094_68.GIF"
KB2SCS(380) = "094_69.GIF"
KB2SCS(381) = "094_70.GIF"
KB2SCS(382) = "094_71.GIF"
KB2SCS(383) = "094_72.GIF"
KB2SCS(384) = "094_73.GIF"
KB2SCS(385) = "094_74.GIF"
KB2SCS(386) = "094_75.GIF"
KB2SCS(387) = "094_76.GIF"
KB2SCS(388) = "094_77.GIF"
KB2SCS(389) = "094_78.GIF"
KB2SCS(390) = "094_79.GIF"
KB2SCS(391) = "094_80.GIF"
KB2SCS(392) = "094_81.GIF"
KB2SCS(393) = "094_82.GIF"
KB2SCS(394) = "094_83.GIF"
KB2SCS(395) = "094_84.GIF"
KB2SCS(396) = "094_85.GIF"
KB2SCS(397) = "094_86.GIF"
KB2SCS(398) = "094_87.GIF"
KB2SCS(399) = "094_88.GIF"
KB2SCS(400) = "094_89.GIF"
KB2SCS(401) = "094_90.GIF"
KB2SCS(402) = "095_48.GIF"
KB2SCS(403) = "095_49.GIF"
KB2SCS(404) = "095_50.GIF"
KB2SCS(405) = "095_51.GIF"
KB2SCS(406) = "095_52.GIF"
KB2SCS(407) = "095_53.GIF"
KB2SCS(408) = "095_54.GIF"
KB2SCS(409) = "095_55.GIF"
KB2SCS(410) = "095_56.GIF"
KB2SCS(411) = "095_57.GIF"
KB2SCS(412) = "095_65.GIF"
KB2SCS(413) = "095_66.GIF"
KB2SCS(414) = "095_67.GIF"
KB2SCS(415) = "095_68.GIF"
KB2SCS(416) = "095_69.GIF"
KB2SCS(417) = "095_70.GIF"
KB2SCS(418) = "095_71.GIF"
KB2SCS(419) = "095_72.GIF"
KB2SCS(420) = "095_73.GIF"
KB2SCS(421) = "095_74.GIF"
KB2SCS(422) = "095_75.GIF"
KB2SCS(423) = "095_76.GIF"
KB2SCS(424) = "095_77.GIF"
KB2SCS(425) = "095_78.GIF"
KB2SCS(426) = "095_79.GIF"
KB2SCS(427) = "095_80.GIF"
KB2SCS(428) = "095_81.GIF"
KB2SCS(429) = "095_82.GIF"
KB2SCS(430) = "095_83.GIF"
KB2SCS(431) = "095_84.GIF"
KB2SCS(432) = "095_85.GIF"
KB2SCS(433) = "095_86.GIF"
KB2SCS(434) = "095_87.GIF"
KB2SCS(435) = "095_88.GIF"
KB2SCS(436) = "095_89.GIF"
KB2SCS(437) = "095_90.GIF"
KB2SCS(438) = "096.GIF"
KB2SCS(439) = "097_48.GIF"
KB2SCS(440) = "097_49.GIF"
KB2SCS(441) = "097_50.GIF"
KB2SCS(442) = "097_51.GIF"
KB2SCS(443) = "097_52.GIF"
KB2SCS(444) = "097_53.GIF"
KB2SCS(445) = "097_54.GIF"
KB2SCS(446) = "097_55.GIF"
KB2SCS(447) = "097_56.GIF"
KB2SCS(448) = "097_57.GIF"
KB2SCS(449) = "097_65.GIF"
KB2SCS(450) = "097_66.GIF"
KB2SCS(451) = "097_67.GIF"
KB2SCS(452) = "097_68.GIF"
KB2SCS(453) = "097_69.GIF"
KB2SCS(454) = "097_70.GIF"
KB2SCS(455) = "097_71.GIF"
KB2SCS(456) = "097_72.GIF"
KB2SCS(457) = "097_73.GIF"
KB2SCS(458) = "097_74.GIF"
KB2SCS(459) = "097_75.GIF"
KB2SCS(460) = "097_76.GIF"
KB2SCS(461) = "097_77.GIF"
KB2SCS(462) = "097_78.GIF"
KB2SCS(463) = "097_79.GIF"
KB2SCS(464) = "097_80.GIF"
KB2SCS(465) = "097_81.GIF"
KB2SCS(466) = "097_82.GIF"
KB2SCS(467) = "097_83.GIF"
KB2SCS(468) = "097_84.GIF"
KB2SCS(469) = "097_85.GIF"
KB2SCS(470) = "097_86.GIF"
KB2SCS(471) = "097_87.GIF"
KB2SCS(472) = "097_88.GIF"
KB2SCS(473) = "097_89.GIF"
KB2SCS(474) = "097_90.GIF"
KB2SCS(475) = "098.GIF"
KB2SCS(476) = "099_48.GIF"
KB2SCS(477) = "099_49.GIF"
KB2SCS(478) = "099_50.GIF"
KB2SCS(479) = "099_51.GIF"
KB2SCS(480) = "099_52.GIF"
KB2SCS(481) = "099_53.GIF"
KB2SCS(482) = "099_54.GIF"
KB2SCS(483) = "099_55.GIF"
KB2SCS(484) = "099_56.GIF"
KB2SCS(485) = "099_57.GIF"
KB2SCS(486) = "099_65.GIF"
KB2SCS(487) = "099_66.GIF"
KB2SCS(488) = "099_67.GIF"
KB2SCS(489) = "099_68.GIF"
KB2SCS(490) = "099_69.GIF"
KB2SCS(491) = "099_70.GIF"
KB2SCS(492) = "099_71.GIF"
KB2SCS(493) = "099_72.GIF"
KB2SCS(494) = "099_73.GIF"
KB2SCS(495) = "099_74.GIF"
KB2SCS(496) = "099_75.GIF"
KB2SCS(497) = "099_76.GIF"
KB2SCS(498) = "099_77.GIF"
KB2SCS(499) = "099_78.GIF"
KB2SCS(500) = "099_79.GIF"
KB2SCS(501) = "099_80.GIF"
KB2SCS(502) = "099_81.GIF"
KB2SCS(503) = "099_82.GIF"
KB2SCS(504) = "099_83.GIF"
KB2SCS(505) = "099_84.GIF"
KB2SCS(506) = "099_85.GIF"
KB2SCS(507) = "099_86.GIF"
KB2SCS(508) = "099_87.GIF"
KB2SCS(509) = "099_88.GIF"
KB2SCS(510) = "099_89.GIF"
KB2SCS(511) = "099_90.GIF"
KB2SCS(512) = "100.GIF"
KB2SCS(513) = "101.GIF"
KB2SCS(514) = "102.GIF"
KB2SCS(515) = "103.GIF"
KB2SCS(516) = "104.GIF"
KB2SCS(517) = "105_48.GIF"
KB2SCS(518) = "105_49.GIF"
KB2SCS(519) = "105_50.GIF"
KB2SCS(520) = "105_51.GIF"
KB2SCS(521) = "105_52.GIF"
KB2SCS(522) = "105_53.GIF"
KB2SCS(523) = "105_54.GIF"
KB2SCS(524) = "105_55.GIF"
KB2SCS(525) = "105_56.GIF"
KB2SCS(526) = "105_57.GIF"
KB2SCS(527) = "105_65.GIF"
KB2SCS(528) = "105_66.GIF"
KB2SCS(529) = "105_67.GIF"
KB2SCS(530) = "105_68.GIF"
KB2SCS(531) = "105_69.GIF"
KB2SCS(532) = "105_70.GIF"
KB2SCS(533) = "105_71.GIF"
KB2SCS(534) = "105_72.GIF"
KB2SCS(535) = "105_73.GIF"
KB2SCS(536) = "105_74.GIF"
KB2SCS(537) = "105_75.GIF"
KB2SCS(538) = "105_76.GIF"
KB2SCS(539) = "105_77.GIF"
KB2SCS(540) = "105_78.GIF"
KB2SCS(541) = "105_79.GIF"
KB2SCS(542) = "105_80.GIF"
KB2SCS(543) = "105_81.GIF"
KB2SCS(544) = "105_82.GIF"
KB2SCS(545) = "105_83.GIF"
KB2SCS(546) = "105_84.GIF"
KB2SCS(547) = "105_85.GIF"
KB2SCS(548) = "105_86.GIF"
KB2SCS(549) = "105_87.GIF"
KB2SCS(550) = "105_88.GIF"
KB2SCS(551) = "105_89.GIF"
KB2SCS(552) = "105_90.GIF"
KB2SCS(553) = "106.GIF"
KB2SCS(554) = "107.GIF"
KB2SCS(555) = "108.GIF"
KB2SCS(556) = "110_48.GIF"
KB2SCS(557) = "110_49.GIF"
KB2SCS(558) = "110_50.GIF"
KB2SCS(559) = "110_51.GIF"
KB2SCS(560) = "110_52.GIF"
KB2SCS(561) = "110_53.GIF"
KB2SCS(562) = "110_54.GIF"
KB2SCS(563) = "110_55.GIF"
KB2SCS(564) = "110_56.GIF"
KB2SCS(565) = "110_57.GIF"
KB2SCS(566) = "110_65.GIF"
KB2SCS(567) = "110_66.GIF"
KB2SCS(568) = "110_67.GIF"
KB2SCS(569) = "110_68.GIF"
KB2SCS(570) = "110_69.GIF"
KB2SCS(571) = "110_70.GIF"
KB2SCS(572) = "110_71.GIF"
KB2SCS(573) = "110_72.GIF"
KB2SCS(574) = "110_73.GIF"
KB2SCS(575) = "110_74.GIF"
KB2SCS(576) = "110_75.GIF"
KB2SCS(577) = "110_76.GIF"
KB2SCS(578) = "110_77.GIF"
KB2SCS(579) = "110_78.GIF"
KB2SCS(580) = "110_79.GIF"
KB2SCS(581) = "110_80.GIF"
KB2SCS(582) = "110_81.GIF"
KB2SCS(583) = "110_82.GIF"
KB2SCS(584) = "110_83.GIF"
KB2SCS(585) = "110_84.GIF"
KB2SCS(586) = "110_85.GIF"
KB2SCS(587) = "110_86.GIF"
KB2SCS(588) = "110_87.GIF"
KB2SCS(589) = "110_88.GIF"
KB2SCS(590) = "110_89.GIF"
KB2SCS(591) = "110_90.GIF"
KB2SCS(592) = "111.GIF"
KB2SCS(593) = "112.GIF"
KB2SCS(594) = "113.GIF"
KB2SCS(595) = "114.GIF"
KB2SCS(596) = "115_48.GIF"
KB2SCS(597) = "115_49.GIF"
KB2SCS(598) = "115_50.GIF"
KB2SCS(599) = "115_51.GIF"
KB2SCS(600) = "115_52.GIF"
KB2SCS(601) = "115_53.GIF"
KB2SCS(602) = "115_54.GIF"
KB2SCS(603) = "115_55.GIF"
KB2SCS(604) = "115_56.GIF"
KB2SCS(605) = "115_57.GIF"
KB2SCS(606) = "115_65.GIF"
KB2SCS(607) = "115_66.GIF"
KB2SCS(608) = "115_67.GIF"
KB2SCS(609) = "115_68.GIF"
KB2SCS(610) = "115_69.GIF"
KB2SCS(611) = "115_70.GIF"
KB2SCS(612) = "115_71.GIF"
KB2SCS(613) = "115_72.GIF"
KB2SCS(614) = "115_73.GIF"
KB2SCS(615) = "115_74.GIF"
KB2SCS(616) = "115_75.GIF"
KB2SCS(617) = "115_76.GIF"
KB2SCS(618) = "115_77.GIF"
KB2SCS(619) = "115_78.GIF"
KB2SCS(620) = "115_79.GIF"
KB2SCS(621) = "115_80.GIF"
KB2SCS(622) = "115_81.GIF"
KB2SCS(623) = "115_82.GIF"
KB2SCS(624) = "115_83.GIF"
KB2SCS(625) = "115_84.GIF"
KB2SCS(626) = "115_85.GIF"
KB2SCS(627) = "115_86.GIF"
KB2SCS(628) = "115_87.GIF"
KB2SCS(629) = "115_88.GIF"
KB2SCS(630) = "115_89.GIF"
KB2SCS(631) = "115_90.GIF"
KB2SCS(632) = "116.GIF"
KB2SCS(633) = "117_48.GIF"
KB2SCS(634) = "117_49.GIF"
KB2SCS(635) = "117_50.GIF"
KB2SCS(636) = "117_51.GIF"
KB2SCS(637) = "117_52.GIF"
KB2SCS(638) = "117_53.GIF"
KB2SCS(639) = "117_54.GIF"
KB2SCS(640) = "117_55.GIF"
KB2SCS(641) = "117_56.GIF"
KB2SCS(642) = "117_57.GIF"
KB2SCS(643) = "117_65.GIF"
KB2SCS(644) = "117_66.GIF"
KB2SCS(645) = "117_67.GIF"
KB2SCS(646) = "117_68.GIF"
KB2SCS(647) = "117_69.GIF"
KB2SCS(648) = "117_70.GIF"
KB2SCS(649) = "117_71.GIF"
KB2SCS(650) = "117_72.GIF"
KB2SCS(651) = "117_73.GIF"
KB2SCS(652) = "117_74.GIF"
KB2SCS(653) = "117_75.GIF"
KB2SCS(654) = "117_76.GIF"
KB2SCS(655) = "117_77.GIF"
KB2SCS(656) = "117_78.GIF"
KB2SCS(657) = "117_79.GIF"
KB2SCS(658) = "117_80.GIF"
KB2SCS(659) = "117_81.GIF"
KB2SCS(660) = "117_82.GIF"
KB2SCS(661) = "117_83.GIF"
KB2SCS(662) = "117_84.GIF"
KB2SCS(663) = "117_85.GIF"
KB2SCS(664) = "117_86.GIF"
KB2SCS(665) = "117_87.GIF"
KB2SCS(666) = "117_88.GIF"
KB2SCS(667) = "117_89.GIF"
KB2SCS(668) = "117_90.GIF"
KB2SCS(669) = "118_48.GIF"
KB2SCS(670) = "118_49.GIF"
KB2SCS(671) = "118_50.GIF"
KB2SCS(672) = "118_51.GIF"
KB2SCS(673) = "118_52.GIF"
KB2SCS(674) = "118_53.GIF"
KB2SCS(675) = "118_54.GIF"
KB2SCS(676) = "118_55.GIF"
KB2SCS(677) = "118_56.GIF"
KB2SCS(678) = "118_57.GIF"
KB2SCS(679) = "118_65.GIF"
KB2SCS(680) = "118_66.GIF"
KB2SCS(681) = "118_67.GIF"
KB2SCS(682) = "118_68.GIF"
KB2SCS(683) = "118_69.GIF"
KB2SCS(684) = "118_70.GIF"
KB2SCS(685) = "118_71.GIF"
KB2SCS(686) = "118_72.GIF"
KB2SCS(687) = "118_73.GIF"
KB2SCS(688) = "118_74.GIF"
KB2SCS(689) = "118_75.GIF"
KB2SCS(690) = "118_76.GIF"
KB2SCS(691) = "118_77.GIF"
KB2SCS(692) = "118_78.GIF"
KB2SCS(693) = "118_79.GIF"
KB2SCS(694) = "118_80.GIF"
KB2SCS(695) = "118_81.GIF"
KB2SCS(696) = "118_82.GIF"
KB2SCS(697) = "118_83.GIF"
KB2SCS(698) = "118_84.GIF"
KB2SCS(699) = "118_85.GIF"
KB2SCS(700) = "118_86.GIF"
KB2SCS(701) = "118_87.GIF"
KB2SCS(702) = "118_88.GIF"
KB2SCS(703) = "118_89.GIF"
KB2SCS(704) = "118_90.GIF"
KB2SCS(705) = "119.GIF"
KB2SCS(706) = "120.GIF"
KB2SCS(707) = "121.GIF"
KB2SCS(708) = "122_48.GIF"
KB2SCS(709) = "122_49.GIF"
KB2SCS(710) = "122_50.GIF"
KB2SCS(711) = "122_51.GIF"
KB2SCS(712) = "122_52.GIF"
KB2SCS(713) = "122_53.GIF"
KB2SCS(714) = "122_54.GIF"
KB2SCS(715) = "122_55.GIF"
KB2SCS(716) = "122_56.GIF"
KB2SCS(717) = "122_57.GIF"
KB2SCS(718) = "122_65.GIF"
KB2SCS(719) = "122_66.GIF"
KB2SCS(720) = "122_67.GIF"
KB2SCS(721) = "122_68.GIF"
KB2SCS(722) = "122_69.GIF"
KB2SCS(723) = "122_70.GIF"
KB2SCS(724) = "122_71.GIF"
KB2SCS(725) = "122_72.GIF"
KB2SCS(726) = "122_73.GIF"
KB2SCS(727) = "122_74.GIF"
KB2SCS(728) = "122_75.GIF"
KB2SCS(729) = "122_76.GIF"
KB2SCS(730) = "122_77.GIF"
KB2SCS(731) = "122_78.GIF"
KB2SCS(732) = "122_79.GIF"
KB2SCS(733) = "122_80.GIF"
KB2SCS(734) = "122_81.GIF"
KB2SCS(735) = "122_82.GIF"
KB2SCS(736) = "122_83.GIF"
KB2SCS(737) = "122_84.GIF"
KB2SCS(738) = "122_85.GIF"
KB2SCS(739) = "122_86.GIF"
KB2SCS(740) = "122_87.GIF"
KB2SCS(741) = "122_88.GIF"
KB2SCS(742) = "122_89.GIF"
KB2SCS(743) = "122_90.GIF"
KB2SCS(744) = "123.GIF"
KB2SCS(745) = "124.GIF"
KB2SCS(746) = "125.GIF"
KB2SCS(747) = "126.GIF"

For Johnb = 1 To 94
  FileCopy JbSourceDir & KB2SCS(Johnb), gstrDestDir & "Symbols\Table1\" & Mid(KB2SCS(Johnb), 1, InStr(KB2SCS(Johnb), "A") - 1) & ".GIF"
Next Johnb

For Johnb = 95 To 747
  FileCopy JbSourceDir & KB2SCS(Johnb), gstrDestDir & "Symbols\Table2\" & KB2SCS(Johnb)
Next Johnb

FileCopy JbSourceDir & "USA.bmp", gstrDestDir & "BitMap\USA.bmp"
FileCopy JbSourceDir & "USA.txt", gstrDestDir & "BitMap\USA.txt"
FileCopy JbSourceDir & "IgateHelp.txt", gstrDestDir & "IgateHelp.txt"
FileCopy JbSourceDir & "WxHelp.txt", gstrDestDir & "WxHelp.txt"


ExitSetup:
    HideStaticMessageDialog
    If fWithinAction() Then
        'By now, all logging actions should have been either aborted or committed.
        MsgError ResolveResString(resSTILLWITHINACTION), vbExclamation Or vbOKOnly, gstrTitle
        ExitSetup Me, gintRET_FATAL
    End If
    MoveAppRemovalFiles strGroupName

    ExitSetup Me, gintRET_FINISHEDSUCCESS

MainError:
    iRet = MsgError(Err.Description & vbLf & vbLf & ResolveResString(resUNEXPECTED), vbRetryCancel Or vbExclamation, gstrTitle)
    If gfNoUserInput Then iRet = vbCancel
    Select Case iRet
        Case vbRetry
            Resume
        Case vbCancel
            ExitSetup Me, gintRET_ABORT
            Resume
    End Select
End Sub

'-----------------------------------------------------------
' SUB: HideCopyDialog
'
' Unloads the copy files status form
'-----------------------------------------------------------
'
Private Sub HideCopyDialog()
    Unload frmCopy
End Sub

'-----------------------------------------------------------
' SUB: HideStaticMessageDialog
'
' Unloads the setup messages form
'-----------------------------------------------------------
'
Private Sub HideStaticMessageDialog()
    Unload frmMessage
End Sub

'-----------------------------------------------------------
' SUB: ShowBeginForm
'
' Displays the begin setup form
'-----------------------------------------------------------
'
Private Sub ShowBeginForm()
    If gfNoUserInput Then
        If Not IsValidDestDir(gstrDestDir) Then
            ExitSetup frmSetup1, gintRET_FATAL
        End If
    Else
        frmBegin.Show vbModal
    End If
End Sub

'-----------------------------------------------------------
' SUB: ShowCopyDialog
'
' Displays the copy files status form
'-----------------------------------------------------------
'
Private Sub ShowCopyDialog()
    CenterForm frmCopy
    If gfNoUserInput Then
        frmCopy.cmdExit.Visible = False
    End If
    frmCopy.Show
    frmCopy.Refresh
    If frmCopy.cmdExit.Visible Then
        frmCopy.cmdExit.SetFocus
    End If
End Sub

'-----------------------------------------------------------
' SUB: ShowMainForm
'
' Displays the main setup 'blue wash' form
'-----------------------------------------------------------
'
Private Sub ShowMainForm()
    Caption = gstrTitle
    Show
    DrawBackGround
    Refresh
End Sub

'-----------------------------------------------------------
' SUB: ShowStaticMessageDialog
'
' Displays a setup message in a 'box' of the appropriate
' size for the message
'
' IN: [strMessage] - message to display
'-----------------------------------------------------------
'
Private Sub ShowStaticMessageDialog(ByVal strMessage As String)
    Dim frm As Form

    Set frm = frmMessage
    frm.lblMsg.Caption = strMessage

    '
    'Default height is twice the height of the setup icon.
    'If the height of the message text is greater, then
    'increase the form height to the label height plus
    'half an icon height
    '
    frm.ScaleHeight = frm.imgMsg.Height * 2
    If frm.lblMsg.Height > frm.ScaleHeight Then
        frm.ScaleHeight = frm.lblMsg.Height + frm.imgMsg.Height * 0.5
    End If

    '
    'Vertically center the icon and label within the form
    '
    frm.imgMsg.Top = frm.ScaleHeight / 2 - frm.imgMsg.Height / 2
    frm.lblMsg.Top = frm.ScaleHeight / 2 - frm.lblMsg.Height / 2

    CenterForm frm

    frm.Show
    frm.Refresh
End Sub

'-----------------------------------------------------------
' SUB: ShowWelcomeForm
'
' Displays the welcome to setup form
'-----------------------------------------------------------
'
Private Sub ShowWelcomeForm()
    If Not gfNoUserInput Then
        frmWelcome.Show vbModal
    End If
End Sub

'-----------------------------------------------------------
' SUB: GetStrings
'
' Loads string resources into global vars and forms/controls
'-----------------------------------------------------------
'
Private Sub GetStrings()
    On Error GoTo GSErr

    gstrSETMSG = ResolveResString(resSETMSG)

    Exit Sub

GSErr:
    MsgError mstrRESOURCELOADFAIL, vbCritical Or vbOKOnly, vbNullString
    ExitSetup Me, gintRET_FATAL
End Sub

Private Sub Form_Unload(Cancel As Integer)
    CleanUpCabs
End Sub
