#include <SIOUX.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define kKey 0x73e2		// This is the seed for the key

short doHash(char *theCall)
{
	char 			rootCall[10];			// need to copy call to remove ssid from parse
	char 			*p1 = rootCall;
	
	while ((*theCall != '-') && (*theCall != 0)) *p1++ = toupper(*theCall++);
	*p1 = 0;
	
	short hash = kKey;			// Initialize with the key value
	short i = 0;
	short len = strlen(rootCall);
	char *ptr = rootCall;
	while (i<len)				// Loop through the string two bytes at a time
	{
		hash ^= (*ptr++)<<8;	// xor high byte with accumulated hash
		hash ^= (*ptr++);		// xor low byte with accumulated hash
		i += 2;
	}
	return hash & 0x7fff;		// mask off the high bit so number is always positive
}

short checkHash(char *theCall, short theHash)
{
	return (doHash(theCall) == theHash);
}

void main()
{
	char	temp[100];
	
	SIOUXSettings.asktosaveonclose = false;
	SIOUXSettings.autocloseonquit = true;
	
	while (true) 
	{
		printf("Enter callsign:");
		gets(temp);
		if (*temp == 0) break;
		printf("Password for %s is %d\n",temp,doHash(temp));
	}
}

